#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo
echo
echo "ANGLES TESTS"
echo
cmdmod /opt/pyrame/cmd_acq.xml > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml -d > varmod.trace 2>&1 &

wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT

exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq /tmp none localhost
exec_n_test chkpyr2.py localhost $ACQ_PORT newunit_acq 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so test_ 8003 null null test 100000 0
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq 0 /opt/pyrame/hle_decoder.so "!time,bcid|x,y,z|en" "undef"
wait_until_awake localhost 21000

cmdmod /opt/calicoes/cmd_angles.xml -a converter_test_0 > angles.trace 2>&1 &
wait_until_awake localhost 21001

exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq

echo '!1,1|0,0,0|250!1,1|10,10,0|250!1,1|20,20,0|250' | tcpc localhost 8003 1
sleep 1s
checkretstr "!1.000000||90.003984" ./get_block.sh 21001 1

clean_all
echo "all test passed"

