#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import time,datetime

progress=0

def unit_test_run_init():
    # declare the global variables that will be set by the run control
    declare_param("xml_config","calxml configuration file","/opt/calicoes/config/test_ecal.xml")
    declare_param("acq_time","duration of acquisition (s)","10")
    declare_param("run_name","name of run","test")
    declare_param("mode","mode (append or remove)","append")

def unit_test_run_run(run_name,xml_config,acq_time,mode):
    global progress
    progress=0

    try:
        deinitialize()
    except:
        pass

    load_config_file(xml_config)
    progress=5

    initialize()
    progress=8

    configure()
    progress=12

    run=new_run(run_name,mode)
    progress=15

    acq=new_acq("single_acq_%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")),run)
    start_acq(acq)
    div=10
    try:
        for i in range(div):
            int_sleep(float(acq_time)/div)
            progress=15+(i+1)*(90-15)/div
    finally:
        stop_acq()
        wait_acq_finished(acq)
        wait_run_finished(run)
        progress=92

    invalidate()
    progress=98

    deinitialize()
    progress=100

def unit_test_run_get_progress():
    return progress

execfile("/opt/calicoes/pycaldaq_rcs.py")
