#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

killall acq_server
sleep 1s
stdbuf -oL -eL acq_server 2>&1 > server.trace&
sleep 1s


exec_n_test ./init.sh
exec_n_test ./add_file_dif4_1.sh
nc localhost $STREAMBASE_PORT > nc_test.txt &
#uncomment this one if you want to have a non passing test
#exec_n_test ./never_work.sh
exec_n_test ./startacq.sh
exec_n_test ./stopacq.sh
exec_n_test ./flush_files.sh test undef undef undef
exec_n_test ./getstats.sh
if test ! -f test_bydif1.raw
then
  echo "no acquisition! check the files!"
  exit 1
fi
RESC=`diff test_bydif1.raw test.txt | head -1`
RESS=`diff nc_test.txt test.txt | head -1`
check_empty "expr:$RESC" "cache"
check_empty "expr:$RESS" "socket"
exec_n_test ./deinit.sh


exec_n_test ./add_eth_lo_dif.sh
nc localhost $STREAMBASE_PORT > nc_test.txt &
exec_n_test ./startacq.sh
send_from_file packet_test.raw lo
exec_n_test ./stopacq.sh
exec_n_test ./flush_files.sh test undef undef undef
exec_n_test ./getstats.sh
exec_n_test ./startacq.sh
send_from_file packet_ctrl_pktid_43081.raw lo
exec_n_test ./get_ckpt_by_id.sh 0 43081
exec_n_test ./stopacq.sh
if test ! -f test_lodif_0.raw
then
  echo "no acquisition! check the files!"
  exit 1
fi
RESC=`diff test_lodif_0.raw ref.trace | head -1`
RESS=`diff nc_test.txt ref.trace | head -1`
check_empty "expr:$RESC" "cache"
check_empty "expr:$RESS" "socket"
exec_n_test ./deinit.sh



echo "all test passed"

killall acq_server

rm -f running* test.ethraw test_bydif*.raw test_trash.raw
rm -f nc_test.txt 
rm -f server.trace

exit 0
