#include "eudaq/Producer.hh"
#include "eudaq/Logger.hh"
#include "eudaq/RawDataEvent.hh"
#include "eudaq/Timer.hh"
#include "eudaq/Utils.hh"
#include "eudaq/OptionParser.hh"
#include "eudaq/Configuration.hh"
#include <iostream>
#include <ostream>
#include <vector>
#include <sstream>

#include <pyrame.h>

using namespace std;

static const string EVENT_TYPE="Test";

class CalicoesProducer : public eudaq::Producer {
public:
  CalicoesProducer(const string & name,const string & runcontrol);
  virtual void OnConfigure(const eudaq::Configuration & config);
  virtual void OnTerminate();
  virtual void OnStopRun();
  virtual void OnStartRun(unsigned param);
  void apply_sequence(vector<string> trans);
  void NewBlock(struct block *b);
  void NewEvt(struct event *e);
  int IsDone();
private:
  struct evloop *el;
  int rc_port;
  string config_file;
  unsigned int run_nb;
  unsigned int event_counter;
  char done;
  int retcode;
  string retstr;
  int current_spill;
  eudaq::RawDataEvent *current_event;
};

void newblock(void *prod,struct event *e);
void newevt(void *prod,struct event *e);
