//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include "BagOfLLE.h"


void Clear(BagOfLLE_t **bLLE)
{
   BagOfLLE_t *tmpBag;
   while(*bLLE) {
      tmpBag = (*bLLE)->next;
      free(*bLLE);
      *bLLE = tmpBag;
   }

}

void pushEnd(LowLevelEvent_t _aLLE, BagOfLLE_t **bLLE)
{

   if (_debug>0)
      printf(" pushing at End ... spill %i bcid %i, dif %i, chip %i\n",
            _aLLE.spill, _aLLE.bcid, _aLLE.difId, _aLLE.chipId);
   if (_debug>0) {
      printf("BEFORE PUSH\n");
      PrintBLLE(bLLE);
   }


   //BagOfLLE_t *tmpBag = NULL;
   BagOfLLE_t *newBag = *bLLE;
   BagOfLLE_t *elem   = (BagOfLLE_t *) malloc(sizeof(BagOfLLE_t));
   //BagOfLLE_t *elem   = malloc(sizeof(BagOfLLE_t));

   elem->aLLE = _aLLE;
   //elem->nbDifOn = 1;
   elem->next = NULL;

   int nDif;
   nDif = newBag->nbDifOn;

   if (_debug>0) {
      printf("------------ BEFORE pushEnd, nbDifOn: %i\n",nDif);
   }

   if (newBag==NULL || (newBag->aLLE.spill==0 && newBag->aLLE.bcid==0) )  //FIXME : to remove
   {
      if (_debug>0)
         printf("pushEnd:: empty bag, push NEW!!!!\n");
      newBag->next = elem;
      newBag->nbDifOn = 1;
   }
   else {
      if (_debug>0)
         printf("pushEnd:: NON-empty bag, push OLD!!!!\n");
      while(newBag->next != NULL)
         newBag = newBag->next;
      newBag->next = elem;
   }

   if (_debug>0) {
      printf("---------- AFTER pushEnd, nbDifOn: %i\n",newBag->nbDifOn);
   }

   bLLE = (&newBag);

   if (_debug>0) {
      printf("AFTER PUSH\n");
      PrintBLLE(&newBag);
   }

   printf("\n\n");

   return;
}


void push(LowLevelEvent_t _aLLE, BagOfLLE_t **bLLE)
{

   if (_debug>0)
      printf(" pushing ... spill %i bcid %i\n",
            _aLLE.spill, _aLLE.bcid);

   BagOfLLE_t *tmpBag = NULL;
   BagOfLLE_t *newBag = *bLLE;
   BagOfLLE_t *elem   = malloc(sizeof(BagOfLLE_t));

   //if (!elem) exit(EXIT_FAILURE);

   elem->aLLE = _aLLE;

   while (newBag
         && ( _aLLE.spill != newBag->aLLE.spill
            || abs(_aLLE.bcid-newBag->aLLE.bcid) > BCID_DIFF )
         ) { //FIXME cut function outside???
      tmpBag = newBag;
      newBag = newBag->next;
   }
   elem->next = newBag;
   if (tmpBag) tmpBag->next = elem;
   else *bLLE = elem;

   return;
}



//void deleteLLE ( LowLevelEvent_t aLLE, BagOfLLE_t **bLLE)
void deleteLLE ( int _spill, int _bcid, BagOfLLE_t **bLLE)
{

   if (*bLLE==NULL) {
      if (_debug>0) printf("empty list\n");
      return;
   }

   BagOfLLE_t *newBag = *bLLE;
   BagOfLLE_t *curBag = newBag;

   while(curBag!=NULL
         && ( _spill != curBag->aLLE.spill
            || abs(_bcid-curBag->aLLE.bcid) > BCID_DIFF
            )
        )
   {
      newBag = curBag->next;
      curBag = newBag;
   }

   newBag = curBag->next;
   free(curBag);

   return;
}


void PrintBLLE(BagOfLLE_t **bLLE)
{

   BagOfLLE_t *btmp = (*bLLE);
   BagOfLLE_t *blle = (*bLLE);
   if (btmp== NULL) {
      printf("PrintBLLE:: empty bag\n");
      return;
   }

   int nbDifOn; //last element

   nbDifOn = BagLength(&btmp);

   printf(">>> PrintBLLE <<<\n"); 
   printf("=== print Bag ===\n");
   printf(">      nbDifOn: %i\n",nbDifOn);
   while (blle->next != NULL) {
      printf("> bag spill %i, bcid %i, dif: %i, chip %i \n",
            blle->aLLE.spill,blle->aLLE.bcid,
            blle->aLLE.difId, blle->aLLE.chipId);
      blle = blle->next;
   }
   printf("====== eoB =======\n");

   return;
}

int BagLength(BagOfLLE_t **bLLE)
{
   int len;
   len = -1;

   BagOfLLE_t *btmp = (*bLLE);
   if (btmp== NULL) {
      printf("BagLength:: empty bag\n");
      return 0;
   }

   while (btmp != NULL) {
      len++;
      btmp = btmp->next;
   }

   return len;
}
