//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include "LowLevelEvent.h"


void initPBLLE()
{
   printf("init poolOfBagLLE\n");
   poolOfBagLLE = malloc(sizeof(LLEChain_t)*BUFFER_SIZE);

   if (_debug>0)
      printf("  poolOfBagLLE initialised\n");
}



LLEChain_t **removeBagLLE(int bagId, int totNbBags)
{
   //int newTotNbBags;
   //newTotNbBags = totNbBags - 1;


   LLEChain_t **newPool = malloc(sizeof(LLEChain_t)*BUFFER_SIZE);

   int iBag;
   int iNewBag;
   iNewBag = -1;
   for (iBag=0; iBag < nbBagLLE; iBag++) {
      if (iBag != bagId) {
         iNewBag++;
         newPool[iNewBag] = poolOfBagLLE[iBag];
      }
   }

   nbBagLLE--;

   return newPool;
}



void addLLEtoBag(LowLevelEvent_t _aLLE, LLEChain_t **bLLE)
{

   if (_debug>0)
      printf(" pushing at End ... spill %i bcid %i, dif %i, chip %i\n",
            _aLLE.spill, _aLLE.bcid, _aLLE.difId, _aLLE.chipId);
   if (_debug>0) {
      printf("BEFORE PUSH\n");
      PrintBLLE(bLLE);
   }


   //LLEChain_t *tmpBag = NULL;
   LLEChain_t *newBag = *bLLE;
   LLEChain_t *elem   = (LLEChain_t *) malloc(sizeof(LLEChain_t));
   //LLEChain_t *elem   = malloc(sizeof(LLEChain_t));

   elem->aLLE = _aLLE;
   elem->next = NULL;


   if (newBag==NULL || (newBag->aLLE.spill==0 && newBag->aLLE.bcid==0) )  //FIXME : to remove
   {
      if (_debug>0)
         printf("addLLEtoBag:: empty bag, push NEW!!!!\n");
      newBag->next = elem;
   }
   else {
      if (_debug>0)
         printf("addLLEtoBag:: NON-empty bag, push OLD!!!!\n");
      while(newBag->next != NULL)
         newBag = newBag->next;
      newBag->next = elem;
   }

   bLLE = (&newBag);

   if (_debug>0) {
      printf("AFTER PUSH\n");
      PrintBLLE(&newBag);
   }

   printf("\n\n");

   return;
}
void deleteLLE ( int _spill, int _bcid, LLEChain_t **bLLE)
{

   if (*bLLE==NULL) {
      if (_debug>0) printf("empty list\n");
      return;
   }

   LLEChain_t *newBag = *bLLE;
   LLEChain_t *curBag = newBag;

   while(curBag!=NULL
         && ( _spill != curBag->aLLE.spill
            || abs(_bcid-curBag->aLLE.bcid) > BCID_DIFF
            )
        )
   {
      newBag = curBag->next;
      curBag = newBag;
   }

   newBag = curBag->next;
   free(curBag);

   return;
}
void PrintBLLE(LLEChain_t **bLLE)
{

   LLEChain_t *btmp = (*bLLE);
   LLEChain_t *blle = (*bLLE);
   if (btmp== NULL) {
      printf("PrintBLLE:: empty bag\n");
      return;
   }

   int nbDifOn; //last element

   nbDifOn = BagLength(&btmp);

   printf(">>> PrintBLLE <<<\n");
   printf("=== print Bag ===\n");
   printf(">      nbDifOn: %i\n",nbDifOn);
   while (blle->next != NULL) {
      printf("> bag spill %i, bcid %i, dif: %i, chip %i \n",
            blle->aLLE.spill,blle->aLLE.bcid,
            blle->aLLE.difId, blle->aLLE.chipId);
      blle = blle->next;
   }
   printf("====== eoB =======\n");

   return;
}
int BagLength(LLEChain_t **bLLE)
{
   int len;
   len = -1;

   LLEChain_t *btmp = (*bLLE);
   if (btmp== NULL) {
      printf("BagLength:: empty bag\n");
      return 0;
   }

   while (btmp != NULL) {
      len++;
      btmp = btmp->next;
   }

   return len;
}



//void openTxtFiles()
//{
//   difFile  = malloc(sizeof(FILE*) * nbOfFiles);
//   //C++ difFile = new FILE*[nbOfFiles];
//
//   FileNLines = malloc(sizeof(int));
//   FileLineNb = malloc(sizeof(int));
//
//   int iFile;
//   if (_debug>0)
//      printf("nbOfFiles to open: %i\n",nbOfFiles);
//   for (iFile=0; iFile<nbOfFiles; iFile++) {
//      difFile[iFile] = fopen(inpFname[iFile],"r");
//      if (difFile[iFile] != NULL) {
//         printf("file %s opened\n",inpFname[iFile]);
//         FileStatus[iFile] = OPENED;
//         FileNLines[iFile] = nblines(inpFname[iFile]);
//         FileLineNb[iFile] = 0;
//      }
//      else {
//         FileStatus[iFile] = ERROR;
//      }
//   }
//
//
//   return;
//}
//
//int cut(LLEChain_t **_blle, LowLevelEvent_t aLLE)
//{
//
//   //if (typeof(*a_event) == typeof(LLEChain_t)) 
//   //{
//   //}
//
//   //LLEChain_t *blle = (LLEChain_t*)a_event;
//
//   LLEChain_t *blle = (*_blle);
//
//
//   if (blle==NULL)
//      return 0;
//
//   if (abs(blle->aLLE.bcid - aLLE.bcid) < BCID_DIFF
//         && blle->aLLE.spill == aLLE.spill
//      )
//   {
//      if (_debug>0)
//         printf("cut OK: %i %i, %i %i\n",
//               blle->aLLE.bcid,aLLE.bcid,
//               blle->aLLE.spill,aLLE.spill);
//      return 1;
//   }
//   else {
//      if (_debug>0)
//         printf("cut NOT OK: %i %i, %i %i\n",
//               blle->aLLE.bcid,aLLE.bcid,
//               blle->aLLE.spill,aLLE.spill);
//      return 0;
//   }
//}
//
//int AllFilesClosed()
//{
//   int iFile;
//   for (iFile=0; iFile<nbOfFiles; iFile++) {
//      if (FileStatus[iFile] == OPENED) { //one of files is still opened then False
//         return 0;
//      }
//   }
//   return 1;
//}
//
//int nblines(char *filename)
//{
//   FILE *f;
//   char c;
//   int lines = -1;
//   f = fopen(filename, "r");
//   if(f == NULL)
//      return 0;
//   while((c = fgetc(f)) != EOF)
//      if(c == '\n')
//         lines++;
//
//   fclose(f);
//   if(c != '\n')
//      lines++;
//   return lines;
//}
//
///*****************************************************************************/
//char *readOneLine(int iFile, FILE *afile)
//{
//   int BUFSIZE = 65536;
//   char * str = (char*)malloc(sizeof(char*)*BUFSIZE);
//   strcpy(str,"-1");
//
//   if (FileLineNb[iFile] >= FileNLines[iFile]-1) {
//      FileStatus[iFile] = CLOSED;
//      return str;
//   }
//
//
//   if (feof(afile) || ferror(afile)) {
//      return str;
//   }
//
//   if (fgets(str,BUFSIZE,afile) != NULL) {
//      //printf("read: %s\n",str);
//      FileLineNb[iFile]++;
//      return str;
//   }
//
//   return str;
//}
//
//int isGoodLLE(LowLevelEvent_t aLLE)
//{
//   if (aLLE.nbHit1 != aLLE.nbHit2)
//      return 0;
//
//   return 1;
//}
//
//LowLevelEvent_t buildLLE(int _idif, char *line)
//{
//   LowLevelEvent_t aLLE;
//   aLLE.difId = _idif;
//   aLLE.spill = -999;
//
//   int chipid;
//   int spill ;
//   int sca   ;
//   int bcid  ;
//
//   //int bc[NB_SCA];
//   int gain1_energy[NB_CHANS];
//   int gain2_energy[NB_CHANS];
//
//   //printf("read (%i) %s\n",_idif,line);
//   int nnn;
//
//   const char *ptr = line;
//   int readOK = sscanf(ptr,"%d %d %d %d %n",&chipid,&spill,&sca,&bcid,&nnn);
//   if (readOK==0)
//      return aLLE;
//   ptr += nnn;
//
//   int ichan;
//   char ctmp1, ctmp2;
//   int tmp1, tmp2;
//
//   int CHAN_OK_1 = 0;
//   int CHAN_OK_2 = 0;
//
//   int _hitId = -1;
//   int _hitId1[NB_CHANS];
//   int _hitId2[NB_CHANS];
//   for (ichan=0; ichan<64; ichan++) {
//      int readok = sscanf(ptr,"%c %d %c %d %n",&ctmp1,&tmp1,&ctmp2,&tmp2,&nnn);
//      if (readok==0) {
//         perror("ffff");
//         return aLLE;
//      }
//      _hitId++;
//
//      if (ctmp1=='T') {
//         gain1_energy[CHAN_OK_1] = tmp1;
//         _hitId1[CHAN_OK_1] = ichan;
//         CHAN_OK_1++;
//      }
//      if (ctmp2=='T') {
//         gain2_energy[CHAN_OK_2] = tmp2;
//         _hitId2[CHAN_OK_2] = ichan;
//         CHAN_OK_2++;
//      }
//      ptr += nnn;
//   }
//
//   aLLE.chipId = chipid;
//   aLLE.spill  = spill ;
//   aLLE.sca    = sca   ;
//   aLLE.bcid   = bcid  ;
//
//   int ichan1;
//   for (ichan1=0; ichan1<CHAN_OK_1; ichan1++) {
//      //printf(" gain1: %d,", gain1_energy[ichan1]);
//      aLLE.en1[ichan1] = gain1_energy[ichan1];
//      aLLE.hitId1[ichan1] = _hitId1[ichan1];
//   }
//   //printf("\n");
//   int ichan2;
//   for (ichan2=0; ichan2<CHAN_OK_2; ichan2++) {
//      //printf(" gain2: %d,", gain2_energy[ichan2]);
//      aLLE.en2[ichan2] = gain2_energy[ichan2];
//      aLLE.hitId2[ichan2] = _hitId2[ichan2];
//   }
//   aLLE.nbHit1 = CHAN_OK_1;
//   aLLE.nbHit2 = CHAN_OK_2;
//
//   return aLLE;
//}
//

