//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#ifndef __LLE__
#define __LLE__

#define NB_CHANS 64
#define NB_CHIPS 4
#define NB_SCA 16
#define BCID_DIFF 2
#define MAXDIFS 100
//"beam & geo"
#define SPILLDIST 200. //ms
#define BCDIST 0.337 //ms
#define DISTDIFDIF 20. //mm
#define CELLSIZE 5. //mm
#define GAPCELLCELL 0.5 //mm
//calibration constant ECAL
#define ECALCALIBR 0.001




#ifdef __cplusplus 
extern "C" {
#endif

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>


#define BUFFER_SIZE 1024*1024 //in 16 bits words
#define BCID_DIFF 2

   //#include "Params.h"


   typedef struct
   {
      int difId;
      int chipId;
      int spill;
      int sca;
      int bcid;
      int nbHit1;
      int nbHit2;
      int en1[64];
      int en2[64];
      int hitId1[64];
      int hitId2[64];

      //int gain1[64];
      //int gain2[64];
   } LowLevelEvent_t ;

   enum IOMode {
      M_File, M_Socket, M_ShMem, M_LCIO
   };

   enum FStat {
      ERROR = -1,
      CLOSED = 0,
      OPENED = 1
   };

   typedef struct LLEChain {
      LowLevelEvent_t aLLE;
      struct LLEChain *next;
   }
   LLEChain_t ;


#ifdef __cplusplus 
   extern "C" int nbBagLLE;
   extern "C" LLEChain_t *globalPoolLLE;
   extern "C" LLEChain_t **poolOfBagLLE;
   extern "C" int nbBagLLE;
   extern "C" void initPBLLE();

   extern "C" void addLLEtoBag(LowLevelEvent_t _aLLE, LLEChain_t **bLLE);

   extern "C" void deleteLLE ( int _spill, int _bcid, LLEChain_t **bLLE);
   extern "C" void Clear(LLEChain_t **bLLE);
   extern "C" void PrintBLLE(LLEChain_t **bLLE);
   extern "C" int BagLength(LLEChain_t **bLLE);
   extern "C" LLEChain_t **removeBagLLE(int bagId, int totNbBags);
   extern "C" int _debug;

#else
   int nbBagLLE;
   LLEChain_t *globalPoolLLE;
   //BagOfLLE_t **poolOfBagLLE;
   LLEChain_t **poolOfBagLLE;

   int nbBagLLE;
   void initPBLLE();

   void addLLEtoBag(LowLevelEvent_t _aLLE, LLEChain_t **bLLE);

   void deleteLLE ( int _spill, int _bcid, LLEChain_t **bLLE);
   void Clear(LLEChain_t **bLLE);
   void PrintBLLE(LLEChain_t **bLLE);
   int BagLength(LLEChain_t **bLLE);
   LLEChain_t **removeBagLLE(int bagId, int totNbBags);
   int _debug;

#endif



#ifdef __cplusplus
}
#endif


#endif
