#include <cstdlib>
#include <iostream>
#include <sstream>
#include <string>
#include <time.h>

#include <map>

//#include <ctype.h>
using namespace std;

#include "lcioBld.h"

#define DEBUG 1

/*****************************************************************************/ 
map<int,string>modeName;
void INIT();
int BUILD();

char *outTxtFname;

//void openTxtFiles();

lcioBld *lcioBLD;

/*****************************************************************************/ 

int main(int argc, char **argv) 
{
   int cmd;
   inpFname = (char**)malloc(NFILES * sizeof(char*));
   //inpFname = malloc(10* sizeof(char));
   //inpFname = new string[NFILES];

   while ((cmd = getopt(argc,argv,"f:s:o:")) != -1) //f: text,s: socket //o: outputmode
      switch (cmd)
      {
         case 'f' :
            inputMode = M_File;
            optind--;
            //nbOfFiles = -1;
            nbOfFiles = 0;
            for ( ;optind<argc && *argv[optind] != '-'; optind++) {
               //inpFname[nbOfFiles] = argv[optind];
               //printf("inpFile nb %i: %s\n",nbOfFiles,inpFname[nbOfFiles].c_str());
               //strcpy(inpFname[nbOfFiles],argv[optind]);
               inpFname[nbOfFiles] = argv[optind];
               printf("arg %i: %s\n",nbOfFiles,inpFname[nbOfFiles]);

               printf("inpFile nb %i: %s\n",nbOfFiles,inpFname[nbOfFiles]);
               nbOfFiles++;
            }
            break;
         case 's' :
            inputMode = M_Socket;
            printf("input from sockets\n");
            break;
         case 'o' :
            outputMode = atoi(optarg);
            printf("outputMode: %s\n",modeName[outputMode].c_str());
            break;
         default :
            break;
      } //endof switch (cmd) & while ((cmd == ...)

   printf("nbOfFiles: %i\n",nbOfFiles);

   printf("inputMode: %i\n",inputMode);


   /****************************************************/
   INIT();
   /****************************************************/


   int nLoop = 0;
   while (BUILD())
   {
      nLoop++;
      if (_debug>0)
      printf("\n======================================\nLOOP %i\n===============================\n",
            nLoop);
   }
   //BUILD();

   return 0;
}

/*****************************************************************************/ 

void INIT()
{
   outTxtFname = (char*)malloc(sizeof(char)*100);
   strcpy(outTxtFname,"output.hievt.txt");
   modeName[0] = "Ascii";
   modeName[1] = "Socket";
   modeName[2] = "ShMem";
   modeName[3] = "LCIO";

   _debug = DEBUG;

   FileStatus = new int[nbOfFiles];
   for (int iFile=0; iFile<nbOfFiles; iFile++) {
      FileStatus[iFile] = 0;
   }

   char HitMapFname[] = "mapping.txt";
   readHitMap(HitMapFname);
   switch (inputMode)
   {
      case M_File :
         //FIXME openTxtFiles();
         break;
      case M_Socket :
         break;
      default:
         break;
   }

   //initialise Pool of Bag of LowLevelEvents-----------
   //initPBLLE();

   switch (outputMode)
   {
      case M_LCIO:
         {
            char colName[] = "SiWEcalTB";
            char outLCioname[] = "test.lcio";
            lcioBLD = new lcioBld(colName,outLCioname);
         }
         break;
      default:
         printf("output mode not supported (yet)\n");
         break;
   }

   initBuilder();

   return;
}

int BUILD()
{
   switch (inputMode)
   {
      case M_File :
         {
            int buildOk;
            buildOk = fillGlobPoolLLE(&globalPoolLLE);

            cutter(&globalPoolLLE);

            //buildBagLLE(&globalPoolLLE);

            fillPoolOfBLLE(poolOfBagLLE);

            HiEvent_t *hiLLEs = exportEvent(poolOfBagLLE);

            int NHEvt = sizeof(hiLLEs)/sizeof(HiEvent_t);

            //---- output ------------
            if (NHEvt>0)
               for (int ihe=0; ihe<NHEvt; ihe++) {
                  if (_debug>0)
                     cout << "writing lcio evt " << ihe << endl;
                  lcioBLD->writeLcioEvt(hiLLEs[ihe]);
               }

            writeHiEvtToTxt(hiLLEs, outTxtFname);

            printf("HEHEHEHEHEHHEHEHE\n");

            if (!buildOk) return 0;
            return 1;
         }
      default :
         break;
   }

   //FIXME -- todo for all modes
   switch (outputMode) {
      case M_LCIO:
         break;
      default:
         break;
   }

   return 0;
}


