//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include "funcs.h"

int initBuilder()
{

   switch(inputMode)
   {
      case M_File:
         {
            openTxtFiles();
         }
      default:
         break;
   }

   initPBLLE();
   nbBagLLE = 0;

   _currentMinSpill = 9999999;
   int iFile;
   if (_debug>0)
      printf("initBuilder:: nbOfFiles = %i\n",nbOfFiles);

   _lastSpill = malloc(sizeof(int));
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      _lastSpill[iFile] = -1;
   }

   _first = 1;

   if (_debug>0)
      printf("initBuilder: Hererrererere\n");

   return 0;
}

int buildBagLLE()
{

   char *aLine;

   if (AllFilesClosed())
      return 0;

   int iFile;
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      aLine = readOneLine(iFile,difFile[iFile]);

      if (!strcmp(aLine,"-1") || FileLineNb[iFile]>=FileNLines[iFile]-1) {
         //printf("file nb %i closed\n",iFile);
         FileStatus[iFile] = CLOSED;
         continue;
      }

      LowLevelEvent_t aLLE;
      aLLE = buildLLE(iFile,aLine);
      free(aLine);

      if (!isGoodLLE(aLLE)) //remove 'bad' LLE before all ..........
         return -1;

      int thisSpill;
      thisSpill = aLLE.spill;

      if (iFile==0)
         _currentMinSpill = thisSpill;
      else if (thisSpill < _currentMinSpill)
         _currentMinSpill = thisSpill;

      int pushed; pushed = 0;
      int iBag;
      if (nbBagLLE>0) {
         if (_debug>0)
            printf("nb of BAGS: %i\n",nbBagLLE);
         for (iBag=0; iBag<nbBagLLE; iBag++) { //Loop over all existing bag (pool)
            printf("TEST bag %i\n",iBag);
            BagOfLLE_t *aBag = (BagOfLLE_t*) poolOfBagLLE[iBag];
            if (_debug>0) {
               printf("  PRINT before test OLD\n");
               PrintBLLE(&aBag);
            }
            //BagOfLLE_t *aBag = poolOfBagLLE[iBag];
            if (cut(&aBag,aLLE)) { //FIXME push new bag
               if (_debug>0)
                  printf("push: old!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
               pushEnd(aLLE,&aBag);
               poolOfBagLLE[iBag] = aBag;
               pushed = 1;

               if (_debug>0) {
                  printf("PRINT after push old!!!!!!!!!!!!!!!!!\n");
                  PrintBLLE(&aBag);
               }
            }
            else {
               if (_debug>0)
                  printf("push old failed !!!!!!!!!!!!!!!!!!!!!!!\n");
            }
         }
      }
      else { //nbBagLLE==0
         printf("FIRST BAG in POOL\n");
         //poolOfBagLLE[0] = NULL;
         BagOfLLE_t *aBag = malloc(sizeof(BagOfLLE_t));
         aBag->aLLE = aLLE;
         aBag->nbDifOn = 1;
         aBag->next = NULL;
         PrintBLLE(&aBag);
         poolOfBagLLE[0] = aBag;
         //free(aBag);
         nbBagLLE=1;
         pushed=1;
      }
      if (!pushed) { //no existing Bag has same spill, bcid +-2
         BagOfLLE_t *aBag;
         aBag = malloc(sizeof(BagOfLLE_t));
         //aBag = NULL;
         if (_debug>0)
            printf("pushEnd: new!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         //FIXME pushEnd(aLLE,&aBag);
         aBag->aLLE = aLLE;
         aBag->nbDifOn = 1;
         aBag->next = NULL;
         poolOfBagLLE[nbBagLLE] = aBag;
         
         if (_debug>0) {
            printf("PRINT BAG nb: %i\n",nbBagLLE);
            PrintBLLE(&aBag);
         }

         nbBagLLE++;
         //free(aBag);
      }
   }

   //int iBag;
   //for (iBag=0; iBag<nbBagLLE; iBag++) { //Loop over all existing bag (pool)
   //   BagOfLLE_t *aBag = (BagOfLLE_t*) poolOfBagLLE[iBag];
   //   printf("CHECK readiness %i\n",iBag);
   //   if (aBag->aLLE.spill < _currentMinSpill) {
   //      printf("bag %i spill %i ready to be built\n",iBag,aBag->aLLE.spill);
   //      aBag->ready = 1; //FIXME only set first elem in list, to change to whole list???
   //   }
   //   poolOfBagLLE[iBag] = aBag;
   //}

   return 1;
}

HiEvent_t *exportEvent(BagOfLLE_t ** _poolBLLE)
{
   //printf("exportEvent ................\n");

   HiEvent_t *hiEvt;
   hiEvt = malloc(sizeof(HiEvent_t*)*BUFFER_SIZE);

   int iHiE; //nb of HLE to export
   iHiE = -1;

   printf("nbBagLLE: %i\n",nbBagLLE);

   int iBag;

   int *listBuiltBag = malloc(sizeof(int));
   int nbBuiltBag; nbBuiltBag = 0;

   for (iBag=0; iBag<nbBagLLE; iBag++) {
      BagOfLLE_t *aBag = (BagOfLLE_t*) poolOfBagLLE[iBag];
      //BagOfLLE_t aBag;
      //aBag = poolOfBagLLE[iBag];

      if (_debug>0)
         printf("check if bag ready: spill %i -- curr. min %i\n",
               aBag->aLLE.spill, _currentMinSpill);

      //if (aBag->ready) //FIXME
      if (aBag->aLLE.spill < _currentMinSpill)
      {
         iHiE ++;
         if (_debug>0)
            printf("exporting %i \n",iHiE);
         hiEvt[iHiE] = buildHiEvt(&aBag);

         nbBuiltBag++;
         listBuiltBag[nbBuiltBag] = iBag;
      }
   }

   //FIXME FIXME FIXME FIXME
   if (nbBuiltBag>0) {
      int iBuilt;
      if (_debug>0)
         printf("cleaning built bag of LLE\n");
      for (iBuilt=0; iBuilt<nbBuiltBag; iBuilt++) {
         poolOfBagLLE = removeBagLLE(listBuiltBag[iBuilt],nbBagLLE);
      }
   }


   return hiEvt;
}

int startBuilder()
{
   //initPBLLE();

   BagOfLLE_t *bagLLE;
   bagLLE = malloc(sizeof(BagOfLLE_t*));

   //int nbBagLLE;
   nbBagLLE = 0;

   switch (inputMode)
   {
      case M_File :
         {
            while (!AllFilesClosed())
            {
               int iFile;
               for (iFile=0; iFile<nbOfFiles; iFile++) {
                  if (FileStatus[iFile] == OPENED) {
                     char *aLine;
                     aLine = readOneLine(iFile,difFile[iFile]);
                     FileLineNb[iFile] ++; //protection: linenb must <= total nb lines

                     LowLevelEvent_t aLLE;
                     aLLE = buildLLE(iFile,aLine);

                     if (!isGoodLLE(aLLE)) continue; //jump if nb hits for 2 gains not equal

                     if (nbBagLLE<=0) {
                        push(aLLE,&bagLLE);
                        poolOfBagLLE[0] = bagLLE;
                     }
                     else {
                        int iBag;
                        for (iBag=0; iBag<nbBagLLE; iBag++) {
                           BagOfLLE_t *aBag = (BagOfLLE_t*) poolOfBagLLE[iBag];
                           if (cut(&aBag,aLLE))
                              push(aLLE,&aBag);
                        }
                        nbBagLLE++;
                     }

                  }
                  else continue; //not really needed
               } //for (iFile=0; iFile<nbOfFiles; iFile++)
            } //while (!AllFilesClosed())
            return 0; //DONE
         }
         break;
      default :
         break;
   }
   return -1;
}

//void openTxtFiles()
//{
//   difFile  = malloc(sizeof(FILE*) * nbOfFiles);
//   //C++ difFile = new FILE*[nbOfFiles];
//
//   FileNLines = malloc(sizeof(int));
//   FileLineNb = malloc(sizeof(int));
//
//   int iFile;
//   if (_debug>0)
//      printf("nbOfFiles to open: %i\n",nbOfFiles);
//   for (iFile=0; iFile<nbOfFiles; iFile++) {
//      difFile[iFile] = fopen(inpFname[iFile],"r");
//      if (difFile[iFile] != NULL) {
//         printf("file %s opened\n",inpFname[iFile]);
//         FileStatus[iFile] = OPENED;
//         FileNLines[iFile] = nblines(inpFname[iFile]);
//         FileLineNb[iFile] = 0;
//      }
//      else {
//         FileStatus[iFile] = ERROR;
//      }
//   }
//
//
//   return;
//}
//int cut(void *a_event, LowLevelEvent_t aLLE)
//int cut(BagOfLLE_t **_blle, LowLevelEvent_t aLLE)
//{
//
//   //if (typeof(*a_event) == typeof(BagOfLLE_t)) 
//   //{
//   //}
//
//   //BagOfLLE_t *blle = (BagOfLLE_t*)a_event;
//
//   BagOfLLE_t *blle = (*_blle);
//
//
//   if (blle==NULL)
//      return 0;
//
//   if (abs(blle->aLLE.bcid - aLLE.bcid) < BCID_DIFF
//         && blle->aLLE.spill == aLLE.spill
//      )
//   {
//      if (_debug>0)
//         printf("cut OK: %i %i, %i %i\n",
//               blle->aLLE.bcid,aLLE.bcid,
//               blle->aLLE.spill,aLLE.spill);
//      return 1;
//   }
//   else {
//      if (_debug>0)
//         printf("cut NOT OK: %i %i, %i %i\n",
//               blle->aLLE.bcid,aLLE.bcid,
//               blle->aLLE.spill,aLLE.spill);
//      return 0;
//   }
//}
//
//
//
//int AllFilesClosed()
//{
//   int iFile;
//   for (iFile=0; iFile<nbOfFiles; iFile++) {
//      if (FileStatus[iFile] == OPENED) { //one of files is still opened then False
//         return 0;
//      }
//   }
//   return 1;
//}
////int cut(HiEvent_t *a_event, int _bcid)
////{
////
////   if (abs(a_event->bcid - _bcid) < 2)
////      return 1;
////   else
////      return 0;
////}
//
////void *build(void *raw_event)
////{
////   void *rec_event;
////
////   return rec_event;
////}
//
//void eventSel(void *_bagLLE, void *_OKbagLLE, int _bcid)
//{
//   BagOfLLE_t *blle = (BagOfLLE_t*)_bagLLE;
//   BagOfLLE_t *outputBLLE = malloc(sizeof(BagOfLLE_t*));
//
//
//   while (blle != NULL) {
//      blle = blle->next;
//      if (abs(_bcid == blle->aLLE.bcid) < BCID_DIFF) {
//         outputBLLE->next = blle->next;
//      }
//   }
//
//   memcpy(outputBLLE,_OKbagLLE,sizeof(BagOfLLE_t*));
//
//   return;
//}
//
///*****************************************************************************/ 
///***  for text processing ****************************************************/
//int nblines(char *filename)
//{
//   FILE *f;
//   char c;
//   int lines = -1;
//   f = fopen(filename, "r");
//   if(f == NULL)
//      return 0;
//   while((c = fgetc(f)) != EOF)
//      if(c == '\n')
//         lines++;
//
//   fclose(f);
//   if(c != '\n')
//      lines++;
//   return lines;
//}
//
///*****************************************************************************/
//char *readOneLine(int iFile, FILE *afile)
//{
//   int BUFSIZE = 65536;
//   char * str = (char*)malloc(sizeof(char*)*BUFSIZE);
//   strcpy(str,"-1");
//
//   if (FileLineNb[iFile] >= FileNLines[iFile]-1) {
//      FileStatus[iFile] = CLOSED;
//      return str;
//   }
//
//
//   if (feof(afile) || ferror(afile)) {
//      return str;
//   }
//
//   if (fgets(str,BUFSIZE,afile) != NULL) {
//      //printf("read: %s\n",str);
//      FileLineNb[iFile]++;
//      return str;
//   }
//
//   return str;
//}
//
///*****************************************************************************/
//
//int isGoodLLE(LowLevelEvent_t aLLE)
//{
//   if (aLLE.nbHit1 != aLLE.nbHit2)
//      return 0;
//
//   return 1;
//}
//
//LowLevelEvent_t buildLLE(int _idif, char *line)
//{
//   LowLevelEvent_t aLLE;
//   aLLE.difId = _idif;
//   aLLE.spill = -999;
//
//   int chipid;
//   int spill ;
//   int sca   ;
//   int bcid  ;
//
//   //int bc[NB_SCA];
//   int gain1_energy[NB_CHANS];
//   int gain2_energy[NB_CHANS];
//
//   //printf("read (%i) %s\n",_idif,line);
//   int nnn;
//
//   const char *ptr = line;
//   int readOK = sscanf(ptr,"%d %d %d %d %n",&chipid,&spill,&sca,&bcid,&nnn);
//   if (readOK==0)
//      return aLLE;
//   ptr += nnn;
//
//   int ichan;
//   char ctmp1, ctmp2;
//   int tmp1, tmp2;
//
//   int CHAN_OK_1 = 0;
//   int CHAN_OK_2 = 0;
//
//   int _hitId = -1;
//   int _hitId1[NB_CHANS];
//   int _hitId2[NB_CHANS];
//   for (ichan=0; ichan<64; ichan++) {
//      int readok = sscanf(ptr,"%c %d %c %d %n",&ctmp1,&tmp1,&ctmp2,&tmp2,&nnn);
//      if (readok==0) {
//         perror("ffff");
//         return aLLE;
//      }
//      _hitId++;
//
//      if (ctmp1=='T') {
//         gain1_energy[CHAN_OK_1] = tmp1;
//         _hitId1[CHAN_OK_1] = ichan;
//         CHAN_OK_1++;
//      }
//      if (ctmp2=='T') {
//         gain2_energy[CHAN_OK_2] = tmp2;
//         _hitId2[CHAN_OK_2] = ichan;
//         CHAN_OK_2++;
//      }
//      ptr += nnn;
//   }
//
//   aLLE.chipId = chipid;
//   aLLE.spill  = spill ;
//   aLLE.sca    = sca   ;
//   aLLE.bcid   = bcid  ;
//
//   int ichan1;
//   for (ichan1=0; ichan1<CHAN_OK_1; ichan1++) {
//      //printf(" gain1: %d,", gain1_energy[ichan1]);
//      aLLE.en1[ichan1] = gain1_energy[ichan1];
//      aLLE.hitId1[ichan1] = _hitId1[ichan1];
//   }
//   //printf("\n");
//   int ichan2;
//   for (ichan2=0; ichan2<CHAN_OK_2; ichan2++) {
//      //printf(" gain2: %d,", gain2_energy[ichan2]);
//      aLLE.en2[ichan2] = gain2_energy[ichan2];
//      aLLE.hitId2[ichan2] = _hitId2[ichan2];
//   }
//   //printf("\n");
//
//   aLLE.nbHit1 = CHAN_OK_1;
//   aLLE.nbHit2 = CHAN_OK_2;
//
//   return aLLE;
//}



HiEvent_t buildHiEvt(BagOfLLE_t ** _blle)
{



   BagOfLLE_t *blle = (*_blle);

   HiEvent_t hievt;

   //hievt.evtNum  = (_blle.aLLE).evtNum; //FIXME
   hievt.evtNum  = 0;
   //???hievt.nbDifOn = (_blle.aLLE).nbDifOn;
   //hievt.nbDifOn = blle->nbDifOn;
   hievt.nbDifOn = BagLength(&blle);

   int idif; 
   int totNbHits = 0;
   for (idif=0; idif<hievt.nbDifOn; idif++) {
      //hievt.evDif[idif] = _blle.evDif[idif];

      //int nbHit1 = hievt.evDif[idif].nbHit1;
      //int nbHit2 = hievt.evDif[idif].nbHit2;
      int nbHit = hievt.nbHits;

      totNbHits += nbHit; //FIXME nbHit1 should = nbHit2
   }

   hievt.nbHits = totNbHits;
   hievt.hits = malloc(sizeof(hit_t)*totNbHits);

   printf("buildHiEvt:: nbDifOn = %i\n",hievt.nbDifOn);
   hit_t *hits;
   int ihit = 0;

   for (idif=0; idif<hievt.nbDifOn; idif++) //FIXME
   {
      hits = encodeHit(&blle);
      int nhitdif = blle->aLLE.nbHit1;
      int ihitdif;
      for (ihitdif=0; ihitdif<nhitdif; ihitdif++) {
         hievt.hits[ihit] = hits[ihitdif];
         ihit++;
      }
   }

   return hievt;
}
