//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include "hitInfo.h"


void readHitMap(char *mfname)
{
   chipMap = malloc(sizeof(chanMap_t)*NB_CHIPS);
   int ichi;
   for (ichi=0; ichi<NB_CHIPS; ichi++) {
      chipMap[ichi] = malloc(sizeof(chanMap_t)*NB_CHANS);
   }


   int chip,chan,I,J,size;
   FILE *f;
   f=fopen(mfname,"r");
   while (!feof(f)) {
      fscanf(f,"%d %d %d %d %d",&chip,&chan,&I,&J,&size);
      //printf("chip=%d chan=%d I=%d J=%d size=%d\n",chip,chan,I,J,size);
      chipMap[chip][chan].I=I;
      chipMap[chip][chan].J=J;
      chipMap[chip][chan].size=size;
   }
   fclose(f);

   return;
}

void printHitMap()
{
   int ichi, icha;
   for (ichi=0; ichi<NB_CHIPS; ichi++) {
      for (icha=0; icha<NB_CHANS; icha++) {
         printf("chip=%d chan=%d I=%d J=%d size=%d\n",
               ichi,icha,
               chipMap[ichi][icha].I,
               chipMap[ichi][icha].J,
               chipMap[ichi][icha].size);
      }
   }
   return;
}


hit_t *encodeHit(LLEChain_t **_blle)
{

   LLEChain_t *_bLLE = (*_blle);

   LowLevelEvent_t lle = _bLLE->aLLE;



   int nhits = lle.nbHit1;
   hit_t *hits = malloc(sizeof(hit_t)*nhits);
   
   int difId  = lle.difId;
   int chipId = lle.chipId;
   int bcid   = lle.bcid;
   int spill  = lle.spill;
   
   int ihit;

   for (ihit=0; ihit<nhits; ihit++) {
      int en1 = lle.en1[ihit];
      int en2 = lle.en2[ihit];
      int hitId1 = lle.hitId1[ihit];
      //int hitId2 = lle.hitId2[ihit];

      hits[ihit].E1 = en1*ECALCALIBR;
      hits[ihit].E2 = en2*ECALCALIBR;

      hits[ihit].I = chipMap[chipId][hitId1].I;
      hits[ihit].J = chipMap[chipId][hitId1].J;

      hits[ihit].K = difId; //FIXME layer number
      hits[ihit].M = 0;
      hits[ihit].S = 0;

      hits[ihit].T = spill*SPILLDIST + bcid*BCDIST;

      hits[ihit].Z = difId * DISTDIFDIF;
      hits[ihit].X = (hits[ihit].I + 0.5) * CELLSIZE
         + hits[ihit].I * GAPCELLCELL;

      hits[ihit].Y = (hits[ihit].J + 0.5) * CELLSIZE
         + hits[ihit].J * GAPCELLCELL;

   }


//   if (_debug>0)
//      printf("encodeHit: herererererere\n");

   return hits;
}
