//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

//input.c
#include "input.h"

int initBuilder()
{

   //FileStatus = new int[nbOfFiles];
   FileStatus = malloc( sizeof(int)*BUFFER_SIZE );
   int iFile;
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      FileStatus[iFile] = 0;
   }


   char HitMapFname[] = "mapping.txt";
   readHitMap(HitMapFname);


   poolOfBagLLE = malloc(sizeof(LLEChain_t*)*BUFFER_SIZE);

   switch(inputMode)
   {
      case M_File:
         {
            openTxtFiles();
         }
      default:
         break;
   }

   initPBLLE();
   nbBagLLE = 0;

   _currentMinSpill = 9999999;
   //int iFile;
   if (_debug>0)
      printf("initBuilder:: nbOfFiles = %i\n",nbOfFiles);

   _lastSpill = malloc(sizeof(int));
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      _lastSpill[iFile] = -1;
   }

   _first = 1;

   if (_debug>0)
      printf("initBuilder: Hererrererere\n");

   return 0;
}


void openTxtFiles()
{
   difFile  = malloc(sizeof(FILE*) * nbOfFiles);
   //C++ difFile = new FILE*[nbOfFiles];

   FileNLines = malloc(sizeof(int));
   FileLineNb = malloc(sizeof(int));

   int iFile;
   if (_debug>0)
      printf("nbOfFiles to open: %i\n",nbOfFiles);
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      difFile[iFile] = fopen(inpFname[iFile],"r");
      if (difFile[iFile] != NULL) {
         printf("file %s opened\n",inpFname[iFile]);
         FileStatus[iFile] = OPENED;
         FileNLines[iFile] = nblines(inpFname[iFile]);
         FileLineNb[iFile] = 0;
      }
      else {
         FileStatus[iFile] = ERROR;
      }
   }


   return;
}

int AllFilesClosed()
{
   int iFile;
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      if (FileStatus[iFile] == OPENED) { //one of files is still opened then False
         return 0;
      }
   }
   return 1;
}


int nblines(char *filename)
{
   FILE *f;
   char c;
   int lines = -1;
   f = fopen(filename, "r");
   if(f == NULL)
      return 0;
   while((c = fgetc(f)) != EOF)
      if(c == '\n')
         lines++;

   fclose(f);
   if(c != '\n')
      lines++;
   return lines;
}


/*****************************************************************************/
char *readOneLine(int iFile, FILE *afile)
{
   int BUFSIZE = 65536;
   char * str = (char*)malloc(sizeof(char*)*BUFSIZE);
   strcpy(str,"-1");

   if (FileLineNb[iFile] >= FileNLines[iFile]-1) {
      FileStatus[iFile] = CLOSED;
      return str;
   }


   if (feof(afile) || ferror(afile)) {
      return str;
   }

   if (fgets(str,BUFSIZE,afile) != NULL) {
      //printf("read: %s\n",str);
      FileLineNb[iFile]++;
      return str;
   }

   return str;
}


