//extern "C" {
#include "lcioBld.h"
//}
//extern "C"
//{
//lcioBld::lcioBld()
//{
//   lcWriter=LCFactory::getInstance()->createLCWriter();
//}

lcioBld::lcioBld(char *_collName, char *ofname)
{
   lcWriter=LCFactory::getInstance()->createLCWriter();
   setCollectionName(_collName);
   setOutputFileName(ofname);
   init();
}
lcioBld::~lcioBld()
{
   lcWriter->close();
}
/*****************************************************************************/ 
void lcioBld::init()
{
   lcWriter->open(_outputFname,LCIO::WRITE_NEW);

   flag.setBit(LCIO::CHBIT_LONG);
}

/*****************************************************************************/ 
void lcioBld::writeLcioEvt(HiEvent_t hiEvt)
{
   LCEventImpl* lcioEvt = new LCEventImpl();
   lcioEvt->setRunNumber(0); //FIXME
   lcioEvt->setEventNumber(hiEvt.evtNum);

   LCCollectionVec* calVec=new LCCollectionVec(LCIO::CALORIMETERHIT);
   calVec->setFlag(flag.getFlag());
   CellIDEncoder<CalorimeterHitImpl> cellEnc("M:3,S-1:3,I:9,J:9,K-1:6",calVec);

   for (int ihit=0; ihit<hiEvt.nbHits; ihit++) {
      CalorimeterHitImpl* ahit=new CalorimeterHitImpl();
      ahit->setTime(hiEvt.hits[ihit].T);
      ahit->setEnergy(hiEvt.hits[ihit].E1);
      ahit->setEnergyError(hiEvt.hits[ihit].E2);
      cellEnc["I"]   = hiEvt.hits[ihit].I;
      cellEnc["J"]   = hiEvt.hits[ihit].J;
      cellEnc["M"]   = hiEvt.hits[ihit].M;
      cellEnc["K-1"] = hiEvt.hits[ihit].K;
      cellEnc["S-1"] = hiEvt.hits[ihit].S;
      cellEnc.setCellID(ahit);
      float pos[3];
      pos[0] = hiEvt.hits[ihit].X;
      pos[1] = hiEvt.hits[ihit].Y;
      pos[2] = hiEvt.hits[ihit].Z;

      ahit->setPosition(pos);
      //calVec->push_back(ahit);
      cout << "SET: " << ahit->getPosition()[0] << endl;
      calVec->addElement(ahit);
   }
   lcioEvt->addCollection(calVec,_collectionName);
   lcWriter->writeEvent(lcioEvt);
   delete lcioEvt;

   return;
}
/*****************************************************************************/ 
void lcioBld::setCollectionName(char *_name)
{
   _collectionName = _name;
   return;
}
void lcioBld::setOutputFileName(char *_oname)
{
   _outputFname = _oname;
   return;
}

//}
