//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include "physics.h"

//int cut(LLEChain_t **_blle, LowLevelEvent_t aLLE)
int LLEofBag(LLEChain_t **_blle, LowLevelEvent_t aLLE)
{

   //if (typeof(*a_event) == typeof(LLEChain_t)) 
   //{
   //}

   //LLEChain_t *blle = (LLEChain_t*)a_event;

   LLEChain_t *blle = (*_blle);


   if (blle==NULL)
      return 0;

   if (abs(blle->aLLE.bcid - aLLE.bcid) < BCID_DIFF
         && blle->aLLE.spill == aLLE.spill
      )
   {
      if (_debug>0)
         printf("cut OK: %i %i, %i %i\n",
               blle->aLLE.bcid,aLLE.bcid,
               blle->aLLE.spill,aLLE.spill);
      return 1;
   }
   else {
      if (_debug>0)
         printf("cut NOT OK: %i %i, %i %i\n",
               blle->aLLE.bcid,aLLE.bcid,
               blle->aLLE.spill,aLLE.spill);
      return 0;
   }
}


int isGoodLLE(LowLevelEvent_t aLLE)
{
   if (aLLE.nbHit1 != aLLE.nbHit2)
      return 0;

   return 1;
}



/*****************************************************************************/
// ------building-----
/*****************************************************************************/
LowLevelEvent_t buildLLE(int _idif, char *line)
{
   LowLevelEvent_t aLLE;
   aLLE.difId = _idif;
   aLLE.spill = -999;

   int chipid;
   int spill ;
   int sca   ;
   int bcid  ;

   //int bc[NB_SCA];
   int gain1_energy[NB_CHANS];
   int gain2_energy[NB_CHANS];

   //printf("read (%i) %s\n",_idif,line);
   int nnn;

   const char *ptr = line;
   int readOK = sscanf(ptr,"%d %d %d %d %n",&chipid,&spill,&sca,&bcid,&nnn);
   if (readOK==0)
      return aLLE;
   ptr += nnn;

   int ichan;
   char ctmp1, ctmp2;
   int tmp1, tmp2;

   int CHAN_OK_1 = 0;
   int CHAN_OK_2 = 0;

   int _hitId = -1;
   int _hitId1[NB_CHANS];
   int _hitId2[NB_CHANS];
   for (ichan=0; ichan<64; ichan++) {
      int readok = sscanf(ptr,"%c %d %c %d %n",&ctmp1,&tmp1,&ctmp2,&tmp2,&nnn);
      if (readok==0) {
         perror("ffff");
         return aLLE;
      }
      _hitId++;
      if (ctmp1=='T') {
         gain1_energy[CHAN_OK_1] = tmp1;
         _hitId1[CHAN_OK_1] = ichan;
         CHAN_OK_1++;
      }
      if (ctmp2=='T') {
         gain2_energy[CHAN_OK_2] = tmp2;
         _hitId2[CHAN_OK_2] = ichan;
         CHAN_OK_2++;
      }
      ptr += nnn;
   }

   aLLE.chipId = chipid;
   aLLE.spill  = spill ;
   aLLE.sca    = sca   ;
   aLLE.bcid   = bcid  ;

   int ichan1;
   for (ichan1=0; ichan1<CHAN_OK_1; ichan1++) {
      //printf(" gain1: %d,", gain1_energy[ichan1]);
      aLLE.en1[ichan1] = gain1_energy[ichan1];
      aLLE.hitId1[ichan1] = _hitId1[ichan1];
   }
   //printf("\n");
   int ichan2;
   for (ichan2=0; ichan2<CHAN_OK_2; ichan2++) {
      //printf(" gain2: %d,", gain2_energy[ichan2]);
      aLLE.en2[ichan2] = gain2_energy[ichan2];
      aLLE.hitId2[ichan2] = _hitId2[ichan2];
   }
   aLLE.nbHit1 = CHAN_OK_1;
   aLLE.nbHit2 = CHAN_OK_2;

   return aLLE;
}


int fillGlobPoolLLE(LLEChain_t **_poolLLE)
{

   char *aLine;

   if (AllFilesClosed())
      return 0;

   int iFile;
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      aLine = readOneLine(iFile,difFile[iFile]);

      if (!strcmp(aLine,"-1") || FileLineNb[iFile]>=FileNLines[iFile]-1) {
         //printf("file nb %i closed\n",iFile);
         FileStatus[iFile] = CLOSED;
         continue;
      }

      LowLevelEvent_t aLLE;
      aLLE = buildLLE(iFile,aLine);
      free(aLine);


      int thisSpill;
      thisSpill = aLLE.spill;

      if (iFile==0)
         _currentMinSpill = thisSpill;
      else if (thisSpill < _currentMinSpill)
         _currentMinSpill = thisSpill;

      //addLLEtoBag(aLLE, &globalPoolLLE); //change to use local parameter
      //addLLEtoBag(aLLE, &_poolLLE);
      addLLEtoBag(aLLE, _poolLLE);
   }
   return 1;
}


int fillPoolOfBLLE(LLEChain_t **_poolLLE)
{

   LLEChain_t *poolLLE = (LLEChain_t*) _poolLLE;
   //LLEChain_t **poolLLE = _poolLLE;
   while (poolLLE!=NULL) {
      LowLevelEvent_t aLLE = poolLLE->aLLE;

      int iBag;
      int pushed; pushed = 0;
      if (nbBagLLE>0) {
         for (iBag=0; iBag<nbBagLLE; iBag++) {
            LLEChain_t *aBag = (LLEChain_t*) poolOfBagLLE[iBag];
            if (LLEofBag(&aBag,aLLE)) {
               addLLEtoBag(aLLE,&aBag);
               poolOfBagLLE[iBag] = aBag;
               pushed = 1;
            }
         }
      }
      else {
         LLEChain_t *aBag = malloc(sizeof(LLEChain_t));
         aBag->aLLE = aLLE;
         aBag->next = NULL;
         poolOfBagLLE[0] = aBag;
         nbBagLLE=1;
         pushed=1;
      }
      if (!pushed) { //no existing Bag has same spill, bcid +-2
         LLEChain_t *aBag;
         aBag = malloc(sizeof(LLEChain_t));
         //aBag = NULL;
         if (_debug>0)
            printf("addLLEtoBag: new!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         //FIXME addLLEtoBag(aLLE,&aBag);
         aBag->aLLE = aLLE;
         aBag->next = NULL;
         poolOfBagLLE[nbBagLLE] = aBag;

         if (_debug>0) {
            printf("PRINT BAG nb: %i\n",nbBagLLE);
            PrintBLLE(&aBag);
         }

         nbBagLLE++;
         //free(aBag);
      }

      poolLLE = poolLLE->next;
   }

   _poolLLE = &poolLLE;

   return 1;
}


int fillGlobPoolLLE_bk()
{

   char *aLine;

   if (AllFilesClosed())
      return 0;

   int iFile;
   for (iFile=0; iFile<nbOfFiles; iFile++) {
      aLine = readOneLine(iFile,difFile[iFile]);

      if (!strcmp(aLine,"-1") || FileLineNb[iFile]>=FileNLines[iFile]-1) {
         //printf("file nb %i closed\n",iFile);
         FileStatus[iFile] = CLOSED;
         continue;
      }

      LowLevelEvent_t aLLE;
      aLLE = buildLLE(iFile,aLine);
      free(aLine);

//      if (!isGoodLLE(aLLE)) //remove 'bad' LLE before all ..........
//         return -1;

      int thisSpill;
      thisSpill = aLLE.spill;

      if (iFile==0)
         _currentMinSpill = thisSpill;
      else if (thisSpill < _currentMinSpill)
         _currentMinSpill = thisSpill;

      int pushed; pushed = 0;
      int iBag;
      if (nbBagLLE>0) {
         if (_debug>0)
            printf("nb of BAGS: %i\n",nbBagLLE);
         for (iBag=0; iBag<nbBagLLE; iBag++) { //Loop over all existing bag (pool)
            printf("TEST bag %i\n",iBag);
            LLEChain_t *aBag = (LLEChain_t*) poolOfBagLLE[iBag];
            if (_debug>0) {
               printf("  PRINT before test OLD\n");
               PrintBLLE(&aBag);
            }
            //LLEChain_t *aBag = poolOfBagLLE[iBag];
            if (LLEofBag(&aBag,aLLE)) { //FIXME push new bag
               if (_debug>0)
                  printf("push: old!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
               addLLEtoBag(aLLE,&aBag);
               poolOfBagLLE[iBag] = aBag;
               pushed = 1;

               if (_debug>0) {
                  printf("PRINT after push old!!!!!!!!!!!!!!!!!\n");
                  PrintBLLE(&aBag);
               }
            }
            else {
               if (_debug>0)
                  printf("push old failed !!!!!!!!!!!!!!!!!!!!!!!\n");
            }
         }
      }
      else { //nbBagLLE==0
         printf("FIRST BAG in POOL\n");
         //poolOfBagLLE[0] = NULL;
         LLEChain_t *aBag = malloc(sizeof(LLEChain_t));
         aBag->aLLE = aLLE;
         aBag->next = NULL;
         PrintBLLE(&aBag);
         poolOfBagLLE[0] = aBag;
         //free(aBag);
         nbBagLLE=1;
         pushed=1;
      }
      if (!pushed) { //no existing Bag has same spill, bcid +-2
         LLEChain_t *aBag;
         aBag = malloc(sizeof(LLEChain_t));
         //aBag = NULL;
         if (_debug>0)
            printf("addLLEtoBag: new!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         //FIXME addLLEtoBag(aLLE,&aBag);
         aBag->aLLE = aLLE;
         aBag->next = NULL;
         poolOfBagLLE[nbBagLLE] = aBag;

         if (_debug>0) {
            printf("PRINT BAG nb: %i\n",nbBagLLE);
            PrintBLLE(&aBag);
         }

         nbBagLLE++;
         //free(aBag);
      }
   }
   return 1;
}


HiEvent_t buildHiEvt(LLEChain_t ** _blle)
{

   LLEChain_t *blle = (*_blle);

   HiEvent_t hievt;

   //hievt.evtNum  = (_blle.aLLE).evtNum; //FIXME
   hievt.evtNum  = 0;
   hievt.nbDifOn = BagLength(&blle);

   int idif;
   int totNbHits = 0;
   for (idif=0; idif<hievt.nbDifOn; idif++) {
      //hievt.evDif[idif] = _blle.evDif[idif];

      //int nbHit1 = hievt.evDif[idif].nbHit1;
      //int nbHit2 = hievt.evDif[idif].nbHit2;
      int nbHit = hievt.nbHits;

      totNbHits += nbHit; //FIXME nbHit1 should = nbHit2
   }

   hievt.nbHits = totNbHits;
   hievt.hits = malloc(sizeof(hit_t)*totNbHits);

   printf("buildHiEvt:: nbDifOn = %i\n",hievt.nbDifOn);
   hit_t *hits;
   int ihit = 0;

   for (idif=0; idif<hievt.nbDifOn; idif++) //FIXME
   {
      hits = encodeHit(&blle);
      int nhitdif = blle->aLLE.nbHit1;
      int ihitdif;
      for (ihitdif=0; ihitdif<nhitdif; ihitdif++) {
         hievt.hits[ihit] = hits[ihitdif];
         ihit++;
      }
   }

   return hievt;
}

HiEvent_t *exportEvent(LLEChain_t ** _poolBLLE)
{
   HiEvent_t *hiEvt;
   hiEvt = malloc(sizeof(HiEvent_t*)*BUFFER_SIZE);

   int iHiE; //nb of HLE to export
   iHiE = -1;

   printf("nbBagLLE: %i\n",nbBagLLE);

   int iBag;

   int *listBuiltBag = malloc(sizeof(int));
   int nbBuiltBag; nbBuiltBag = 0;

   for (iBag=0; iBag<nbBagLLE; iBag++) {
      LLEChain_t *aBag = (LLEChain_t*) poolOfBagLLE[iBag];
      //LLEChain_t aBag;
      //aBag = poolOfBagLLE[iBag];

      if (_debug>0)
         printf("check if bag ready: spill %i -- curr. min %i\n",
               aBag->aLLE.spill, _currentMinSpill);

      //if (aBag->ready) //FIXME
      if (aBag->aLLE.spill < _currentMinSpill)
      {
         iHiE ++;
         if (_debug>0)
            printf("exporting %i \n",iHiE);
         hiEvt[iHiE] = buildHiEvt(&aBag);

         nbBuiltBag++;
         listBuiltBag[nbBuiltBag] = iBag;
      }
   }

   //FIXME FIXME FIXME FIXME
   if (nbBuiltBag>0) {
      int iBuilt;
      if (_debug>0)
         printf("cleaning built bag of LLE\n");
      for (iBuilt=0; iBuilt<nbBuiltBag; iBuilt++) {
         poolOfBagLLE = removeBagLLE(listBuiltBag[iBuilt],nbBagLLE);
      }
   }


   return hiEvt;

}

int cutter(LLEChain_t **_globalPoolLLE)
{
   LLEChain_t *newpoolLLE = (LLEChain_t*)_globalPoolLLE;
   LLEChain_t *currentpoolLLE = newpoolLLE;
   while (currentpoolLLE!=NULL) {
      currentpoolLLE = currentpoolLLE->next;
      LowLevelEvent_t aLLE = currentpoolLLE->aLLE;
      if (aLLE.nbHit1 != aLLE.nbHit2) {
         newpoolLLE = currentpoolLLE->next;
         currentpoolLLE = newpoolLLE;
      }
   }

   newpoolLLE = currentpoolLLE->next;
   free(currentpoolLLE);
   _globalPoolLLE = &newpoolLLE;
   return 1;
}


//int addNewBagLLE(LLEChain_t **_globPoolLLE, LLEChain_t **_poolBagLLE)
//{
//   LLEChain_t *poolLLE = *_globPoolLLE;
//   LLEChain_t *elem = (LLEChain_t*) malloc (sizeof(LLEChain_t));
//
//   while (poolLLE != NULL) {
//      LowLevelEvent_t aLLE;
//      aLLE = poolLLE->next;
//      int nbBags; //FIXME global parameters??
//      nbBags = sizeof(_poolBagLLE) / sizeof((LLEChain_t*));
//      int iBag;
//      for (iBag=0; iBag<nbBags; iBag++) {
//         LLEChain_t *aBag;
//         aBag = _poolBagLLE[iBag];
//         if (aBag == NULL) {
//            //addLLEtoBag(aLLE,aBag);
//            aBag->aLLE = aLLE;
//            aBag->next = NULL;
//         }
//         else {
//            addLLEtoBag(aLLE,aBag);
//         }
//      }
//   }
//   return 1;
//}

