#include <stdio.h>
#include <TH2F.h>
#include <TThread.h>
#include <TCanvas.h>
#include <TString.h>
#include <TApplication.h>
//#include <THttpServer.h>
#include <pyrame.h>
#include <pthread.h>
#include <TThread.h>

struct or_ws {
  TCanvas *canvas;
  //THttpServer *serv;
  struct evloop **loops;

  //-----------------------------------------------

  TThread *updater_t;

  int last_sca;
  int last_roc;
  int hit_counter;
  int hit_counter_retrig;
  int hit_counter_plane;
  int hit_counter_under;

  int dif_number;

  pthread_mutex_t * updater_mutex;
};

struct loop_ws {

  char first_time;
  int dif_number;
  TH2F *MapEnergy;
  struct or_ws* ows;

};

void *updater(void *workspace) {
  struct or_ws *ws=(struct or_ws *)workspace;
  while(1) {
    pthread_mutex_lock(ws->updater_mutex);
    for (int i=1;i<=ws->dif_number;i++) {
      ws->canvas->cd(i)->Modified();
    }
    ws->canvas->Update();
    pthread_mutex_unlock(ws->updater_mutex);
    usleep(50000);
  }
  return NULL;
}

void newblock(void *workspace,struct block *b) {
  struct loop_ws *ws=(struct loop_ws *)workspace;
  if (ws->first_time) {
    printf("waiting for app to start\n");
    sleep(1);
    ws->first_time=0;
  }
  //printf("new spill : %s\n",get_block_field(b,"spill"));
  //print_block(b);
}

void endblock(void *workspace,struct block *b) {
  //  struct loop_ws *ws=(struct loop_ws *)workspace;

}

void reinit(void *workspace) {
  struct loop_ws *ws=(struct loop_ws *)workspace;
  ws->MapEnergy->Reset();
}


void newevt(void *workspace,struct event *e) {
  struct loop_ws *ws=(struct loop_ws *)workspace;

  pthread_mutex_lock(ws->ows->updater_mutex);

  Double_t energy=(Double_t)atof(get_event_field(e,"en"));
  int hit=atoi(get_event_field(e,"hit"));
  int tag=atoi(get_event_field(e,"tag"));
  Float_t x=-((Float_t)atof(get_event_field(e,"x"))-193.2);
  Float_t y=-((Float_t)atof(get_event_field(e,"y"))-105.8);
  /*
    tag list
    #define bxpn_tag 1
    #define plane_tag 2
    #define underflow_tag 4
    #define overflow_tag 8
  */


  if(x>0 && tag==0  && hit==1) 
    ws->MapEnergy->Fill(x,y,energy);


  pthread_mutex_unlock(ws->ows->updater_mutex);

}


int main(int argc, char **argv) {


  //initialize
  struct or_ws *ws=(struct or_ws *)malloc(sizeof(struct or_ws));

  struct cmd_result *result;
  int port;

  port=get_port("cmod");
  if (port == -1) {
    printf("Error getting port number\n");
    return -1;
  }

  // SENDCMD
  result=sendcmd("localhost",port,"get_name_sublist_cmod","dif","root","end");
  if (result->retcode==0) {
    printf("impossible to get the dif list names\n");
    exit(1);
  }

  char** dif_names = split(result->str,',',&(ws->dif_number));

  /// ------------
  TApplication ecalApp("App",0,NULL);

  ws->updater_mutex=(pthread_mutex_t*)malloc(sizeof(pthread_mutex_t));
  pthread_mutex_init(ws->updater_mutex,NULL);

  //ws->serv=new THttpServer("http:8080");
  ws->canvas = new TCanvas("Monitoring_proto","Monitoring_proto",500,1400);
  ws->canvas->Divide(1,ws->dif_number);
 
  //ws->canvas->cd(0);

  ws->loops=(struct evloop**)malloc(ws->dif_number*sizeof(struct evloop*));

  for(int i=0;i<ws->dif_number; i++) {

    char tmp[1024];
    sprintf(tmp,"converter_%s",dif_names[i]);
    
    struct loop_ws* newlws;
    newlws=(struct loop_ws*)malloc(sizeof(struct loop_ws));
    newlws->MapEnergy = new TH2F(TString::Format("map_energy_%s",tmp),TString::Format("map_energy_%s",tmp),32,-86.5,86.5,32,-86.5,86.5);
    newlws->first_time=1;
    newlws->dif_number=i;
    newlws->ows=ws;
   
    ws->canvas->cd(i+1);
    newlws->MapEnergy->SetTitle(TString::Format("hit_map_%s",tmp));
    newlws->MapEnergy->GetXaxis()->SetTitle("x");
    newlws->MapEnergy->GetYaxis()->SetTitle("y");
    newlws->MapEnergy->Draw("colz");
    newlws->MapEnergy->SetStats(kFALSE);
    ws->canvas->cd(i)->Modified();

  
    ws->loops[i]=new_event_loop(tmp,newlws,newevt,newblock,endblock,reinit,'f');  

  }

  ws->canvas->Update();


  ws->last_sca=-1;
  ws->last_roc=-1;
  for(int i=0;i<ws->dif_number; i++) {
    run_loop(ws->loops[i]);
  }

  ws->updater_t=new TThread("Updater thread",updater,(void *)ws);
  ws->updater_t->Run();

  //run the TApp
  ecalApp.Run(kTRUE);

  //never reached
  return 0;
}

