#include <stdio.h>
#include <TH1F.h>
#include <TThread.h>
#include <TCanvas.h>
#include <TString.h>
#include <TApplication.h>
#include <TGFrame.h>
//#include <THttpServer.h>
#include <pyrame.h>

struct or_ws {
  char first_time;
  TCanvas *canvas;
  TH1D *histo;
  //THttpServer *serv;
  struct evloop *loop;
  TGMainFrame *fmain;
};


void newblock(void *workspace,struct block *b) {
  struct or_ws *ws=(struct or_ws *)workspace;
  if (ws->first_time) {
    printf("waiting for app to start\n");
    sleep(1);
    ws->first_time=0;
  }
  printf("new spill : %s\n",get_block_field(b,"spill"));
  //print_block(b);
}

void endblock(void *workspace,struct block *b) {
}

void reinit(void *workspace) {
}



void newevt(void *workspace,struct event *e) {
  struct or_ws *ws=(struct or_ws *)workspace;
  Double_t energy=(Double_t)atof(get_event_field(e,"en"));
  int hit=atoi(get_event_field(e,"hit"));
  
  //fill the histo with the energy
  printf("filling with energy %f\n",energy);
  if (hit)
    ws->histo->Fill(energy,1.0);
  //ws->canvas->Modified();
  //ws->canvas->Update();
}


int main(int argc, char **argv) {

  if (argc!=2) {
    printf("usage : %s data_source_name\n",argv[0]);
    exit(1);
  }
  
  //initialize
  struct or_ws *ws=(struct or_ws *)malloc(sizeof(struct or_ws));
  TApplication ecalApp("App",&argc,argv);


  ws->loop=new_event_loop(argv[1],ws,newevt,newblock,endblock,reinit,'f');
  if (ws->loop==NULL) {
    printf("error : unable to connect event loop...exiting\n");
    exit(1);
  }


  //ws->serv=new THttpServer("http:8080");
  ws->canvas=new TCanvas("ecal","Ecal Dynamic Histogram",600,600);
  ws->canvas->Divide(1,1);
  ws->canvas->cd(1);
  ws->histo=new TH1D("histo","Energy Histogram on hit after cut",1000,0.0,2000.0);
  //ws->serv->Register("energy",ws->histo);
  ws->histo->Draw();
  ws->canvas->cd(0);

  ws->first_time=1;
  run_loop(ws->loop);
  
  //run the TApp
  ecalApp.Run();

  //never reached
  return 0;
}

