//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <SDL/SDL.h>
#include <time.h>
#include <SDL/SDL_ttf.h>
#include <pyrame.h>

#ifndef max
#define max(a,b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif

//Colors Look-up Table
struct clut {
  float R[256];
  float G[256];
  float B[256];
} clut;
#define FREQ 45.0

#define PIXEL_WIDTH 28
#define PIXEL_SPACING 4

struct cellid {
  int chip;
  int chan;
};

//cell leak parameter
#define LEAK_HIT_VALUE 3
#define LEAK_EN_VALUE 60

enum hc_mode {UNKNOWN,LEAK_HIT,CUMUL_HIT,LEAK_EN,CUMUL_EN};

struct hitcam_ws {
  enum hc_mode mode;
  SDL_Surface *screen;

  //rendering matrices
  int **cumul_hit;
  int **cumul_en;
  int **leak_hit;
  int **leak_en;
  int **first_hit;

  //mapping
  struct cellid **mapping;

  struct clut colors;  
  struct cmd_result *result;
  char *data_ptr;
  int data_ptr_idx;
  int data_buffer_len;
  int last_spill;
  int last_bcid;
  
  //event loop
  struct evloop *loop;
  
  //geometry
  int x;
  int y;
  //statistics
  unsigned char first_data;
  int k;
  //cumulative mode
  int nb_points;
  int max_cumul_hit;
  int max_cumul_en;
  //movie output
  int mo;
  int fnb;
  TTF_Font *font;

} dif_stream;


