/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Calicoes.
*/


/* Get config list */
function update_config_list(callback) {
  pyrame.sendcmd(return_get_file_list,["config_files",4,true,callback],manager_port,"get_config_list_cmod");
}
document.getElementById("get_config_list").onclick=update_loaded_config;


/* Load config */
function load_config() {
  var selected_config=document.getElementById("config_files").value;
  if (selected_config=="None") {
    return;
  }
  function return_deinit_load_config(retcode,res) {
    if (retcode=="0") {
      add_to_error_log(res,1);
      return;
    }
    pyrame.sendcmd(update_loaded_config,null,manager_port,"load_config_file_cmod",selected_config);
  }
  function return_get_state_load_config(retcode,res) {
    if (retcode!="0" && res!="UNDEFINED") {
      pyrame.sendcmd(return_deinit_load_config,null,manager_port,"transition_cmod","ecal","true","deinit","undef");
      return;
    }
    pyrame.sendcmd(update_loaded_config,null,manager_port,"load_config_file_cmod",selected_config);
  }
  pyrame.sendcmd(return_get_state_load_config,null,manager_port,"get_state_ecal","ecal");
}
document.getElementById("reload_config").onclick=load_config;
document.getElementById("config_files").onchange=load_config;


/* update loaded config */
function update_loaded_config(retcode,res) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    // do not return. update loaded config
  }
  // Update config list, then get_config_origin
  update_config_list(function() {
    pyrame.sendcmd(return_get_config_origin,null,manager_port,"get_config_origin_cmod");
  });
  function return_get_config_origin(retcode,res) {
    if (retcode=="0") {
      add_to_error_log(res,1);
      sm_ready=false;
      return;
    }
    var sel=document.getElementById("config_files");
    var opts=sel.options;
    for (var opt,j=0;opt=opts[j];j++) {
      if (opt.value==res) {
        sel.selectedIndex=j;
        break;
      }
    }
    document.getElementById("current_config").innerHTML=res;
    sm_ready=(res!="None");
    //document.getElementById("start_run").disabled=!sm_ready;
    //document.getElementById("stop_run").disabled=!sm_ready;
  }
}

