/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Calicoes.
*/

/* Configuration of GUI */
var manager_port="9014";

/* Ready to operate state machine */
var sm_ready=false
/* Progress bar update period*/
var update_progress_bar_period=2000;
/* Ready to get stats */
var stats_ready=false;
/* Stats update period*/
var update_stats_period=2000;
/* State machine update period*/
var update_sm_period=5000;

/* Default values for transition parameters */
var default_params={"name":"test"}


/* Initialize */
window.onload=function () {
  /* Initialize bindpyrame */
  pyrame=new bindpyrame(window.location.hostname, 80, init_phygui_rc);
}
function init_phygui_rc() {

  /* Initialize API pool */
  apipool=new api_pool();

  /* Errors */
  error_tab=document.getElementById("error_tab");
  error_log=document.getElementById("error_log");

  /* Run Control */
  setInterval(update_progress_bar,update_progress_bar_period);

  /* State Machine */
  transition_buttons=document.querySelectorAll(".transition button");
  setInterval(update_state_machine,update_sm_period);
  for (var i=0;i<transition_buttons.length;i++)
    transition_buttons[i].onclick=transition;
  acq_state_string=document.getElementById("acq_id").innerHTML;

  /* Stats */
  document.getElementById("stats_update_period").innerHTML=(update_stats_period/1000) + " s";
  setInterval(update_stats,update_stats_period);

  /* Tab switching */
  tabs_a=document.querySelectorAll(".tabs .tab-links a");
  for (var i=0;i<tabs_a.length;i++)
    tabs_a[i].addEventListener("click",switch_tab);

  /* RunDB Browser */
  init_rundb_browser();

  /* Online monitors */
  //init_online_monitors();

  /* Update phygui */
  window.onfocus=update_phygui;
  update_phygui();
}


/* Update phygui */
function update_phygui() {
  update_state_machine();
  update_loaded_config();
  update_loaded_script("1");
}



/* Tab switching */
function switch_tab(e) {
  e.preventDefault();
  if (e.currentTarget.parentNode.classList.contains("disabled")) return;
  var currentAttrValue=e.currentTarget.getAttribute("href");
  // Show/Hide Tabs
  var tabs_div=document.querySelectorAll(".tabs div" + currentAttrValue)[0].parentNode.childNodes;
  for (var i=0;i<tabs_div.length;i++)
    if (tabs_div[i].nodeType==1)
      if (currentAttrValue=="#"+tabs_div[i].id) tabs_div[i].style.display="block";
      else tabs_div[i].style.display="none";
  // Change/remove current tab to active
  var tabs_li=tabs_a[0].parentNode.parentNode.childNodes;
  for (var i=0;i<tabs_li.length;i++)
    if (tabs_li[i].nodeType==1)
      tabs_li[i].classList.remove("active");
  this.parentNode.classList.remove("error");
  this.parentNode.classList.add("active");
  if (currentAttrValue=="#script-run") update_loaded_script("1");
  if (currentAttrValue=="#manual-run") update_loaded_config();
  if (currentAttrValue=="#sm") {
    update_loaded_config();
    // give some time to sm_ready to be set
    setTimeout(update_state_machine,200);
  }
  if (currentAttrValue=="#online-monitor") add_monitor();
  if (currentAttrValue=="#stats") {
    update_loaded_config();
    // give some time to sm_ready to be set
    setTimeout(update_state_machine,200);
    setTimeout(update_stats,400);
  }
}
