/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Calicoes.
*/

var rundb_port="9013";

/* RunDB-browser init */
function init_rundb_browser() {
  update_rundb_browser();
}

var rundb_parents={
  "acq":"run",
  "run":"run_g",
  "run_g":"run_g"
};

/* tree update */
function return_get_acq_name(retcode,res,parent_id,acq_id,nb_acqs) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  acqs.push([res,acq_id]);
  if (acqs.length==nb_acqs) {
    acqs.sort();
    var list="";
    for (i=0;i<acqs.length;i++) {
      list+="<li class=\"file\"><a id=\"acq-"+acqs[i][1]+"\" href=\"#rundb-acq-data\">"+acqs[i][0]+"</a></li>";
    }
    acqs=[];
    document.getElementById(parent_id).innerHTML+=list;
  }
}
function return_get_acqs(retcode,res,run_id) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  if (run_id=="root") {
    var parent_id="rundb-tree";
  } else {
    var parent_id="ol-"+run_id;
  }
  if (res!="") {
    var acqs = res.split(",");
    for (var i=0;i<acqs.length;i++) {
      pyrame.sendcmd(return_get_acq_name,[parent_id,acqs[i],acqs.length],rundb_port,"get_acq_name_rundb",acqs[i]);
    }
  }
}
function return_get_runs(retcode,res,parent_run_g) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  if (parent_run_g=="root") {
    var parent_id="rundb-tree";
  } else {
    var parent_id="ol-"+parent_run_g;
  }
  if (res!="") {
    //store run_id and run name in an array, then sort
    var u_runs_id = res.split(",");
    var runs = [];
    for (var i=0;i<u_runs_id.length;i++) {
      var run=u_runs_id[i].split("/");
      runs.push([run[run.length-1],u_runs_id[i]]);
    }
    runs.sort();
    var run_html_list="";
    for (i=0;i<runs.length;i++) {
      run_html_list+="<li id=\"li-"+runs[i][1]+"\"><label id=\"run-"+runs[i][1]+"\" class=\"run\">"+runs[i][0]+"</label></li>";
    }
    document.getElementById(parent_id).innerHTML+=run_html_list;
    for (i=0;i<runs.length;i++) {
      pyrame.sendcmd(return_is_empty,[runs[i][1],"run"],rundb_port,"is_empty_run_rundb",runs[i][1]);
    }
  }
}


function return_get_run_groups(retcode,res,parent_run_g) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  if (parent_run_g=="root") {
    var parent_id="rundb-tree";
  } else {
    var parent_id="ol-"+parent_run_g;
  }
  if (res!="") {
    //store run_g_id and run group name in an array, then sort
    var u_run_groups_id = res.split(",");
    var run_groups = [];
    for (var i=0;i<u_run_groups_id.length;i++) {
      var run_g=u_run_groups_id[i].split("/");
      run_groups.push([run_g[run_g.length-1],u_run_groups_id[i]]);
    }
    run_groups.sort();
    var run_g_html_list="";
    for (i=0;i<run_groups.length;i++) {
      run_g_html_list+="<li id=\"li-"+run_groups[i][1]+"\"><label id=\"run_g-"+run_groups[i][1]+"\" class=\"run_g\">"+run_groups[i][0]+"</label></li>";
    }
    document.getElementById(parent_id).innerHTML+=run_g_html_list;
    for (i=0;i<run_groups.length;i++) {
      pyrame.sendcmd(return_is_empty,[run_groups[i][1],"run_g"],rundb_port,"is_empty_run_group_rundb",run_groups[i][1]);
    }
  }
  pyrame.sendcmd(return_get_runs,parent_run_g,rundb_port,"get_runs_in_run_group_rundb",parent_run_g);
}
function return_is_empty(retcode,res,parent_e,parent_type) {
  // return_is_empty adds a list in parent_e so that a
  // + symbol appears, allowing expansion
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  if (parent_e=="root") {
    var parent_id="rundb-tree";
  } else {
    var parent_id="ol-"+parent_e;
  }
  if (res!="1") {
    // not empty
    if (!document.getElementById(parent_id)) {
      document.getElementById("li-"+parent_e).innerHTML+="<input id=\"ex-"+parent_type+"-"+parent_e+"\" type=\"checkbox\"></input><ol id=\""+parent_id+"\"></ol>";
    }
  }
}
function update_rundb_browser() {
  acqs=[];
  document.getElementById("rundb-tree").innerHTML="";
  pyrame.sendcmd(return_is_empty,["root","run_g"],rundb_port,"is_empty_run_group_rundb","root");
  pyrame.sendcmd(return_get_run_groups,"root",rundb_port,"get_run_groups_in_run_group_rundb","root");
}


/* update tree button */ 
document.getElementById("update-rundb-tree").addEventListener("click",update_rundb_browser);


/* collapse all button */ 
document.getElementById("collapse-all-runs").addEventListener("click", function() {
  var runs=document.querySelectorAll("#rundb-tree input");
  for (var i=0;i<runs.length;i++) {
    runs[i].checked=false;
  }
});


/* view element */
function return_get_el(retcode,res) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  g_type=rundb_parents[rundb_view_type];
  document.getElementById("rundb-"+rundb_view_type+"-id").innerHTML=rundb_view_id;
  var table="";
  // we sort parameters alphabetically
  var params=atob(res).split("\n").sort();
  for (var i=0;i<params.length;i++) {
    var param=params[i].split("\t");
    if (param[0]=="name") {
      //ignore
    } else if (param[0]==g_type+"_id") {
      document.getElementById("rundb-"+rundb_view_type+"-"+g_type).innerHTML=param[1];
    } else {
      table+="<tr><td>"+param[0]+"</td><td>"+param[1]+"</td></tr>";
    }
  }
  if (table=="") {
    document.getElementById("rundb-"+rundb_view_type+"-data-table").innerHTML="";
  } else {
    var table_h="<tr><th>Parameter</th><th>Value</th></tr>";
    document.getElementById("rundb-"+rundb_view_type+"-data-table").innerHTML=table_h+table;
  }
  document.getElementById("rundb-"+rundb_view_type+"-data").style.display="inline-block";
}


/* Click listeners in rundb-tree */
document.getElementById("rundb-tree").addEventListener("click", function(e) {
  // check if the id of the target of the click event starts with ex-run_g-
  if (e.target.id.lastIndexOf("ex-run_g-",0) === 0) {
    var run_g_id=e.target.id.substring(9);
    if (e.target.checked) {
      document.getElementById("ol-"+run_g_id).innerHTML="";
      pyrame.sendcmd(return_get_run_groups,run_g_id,rundb_port,"get_run_groups_in_run_group_rundb",run_g_id);
    }
    return;
  }
  // check if the id of the target of the click event starts with ex-run-
  if (e.target.id.lastIndexOf("ex-run-",0) === 0) {
    var run_id=e.target.id.substring(7);
    if (e.target.checked) {
      document.getElementById("ol-"+run_id).innerHTML="";
      pyrame.sendcmd(return_get_acqs,run_id,rundb_port,"get_acqs_in_run_rundb",run_id);
    }
    return;
  }
  document.getElementById("rundb-acq-data").style.display="none";
  document.getElementById("rundb-run-data").style.display="none";
  document.getElementById("rundb-run_g-data").style.display="none";
  // rundb_view_id and rundb_view_type are global so that
  // we can use them to delete
  rundb_view_id=null;
  rundb_view_type=null;
  // determine view from event target
  if (e.target.id.lastIndexOf("acq-",0) === 0) {
    rundb_view_id=e.target.id.substring(4);
    rundb_view_type=e.target.id.substring(0,3);
    pyrame.sendcmd(return_get_el,null,rundb_port,"get_acq_rundb",rundb_view_id);
  }
  if (e.target.id.lastIndexOf("run-",0) === 0) {
    rundb_view_id=e.target.id.substring(4);
    rundb_view_type=e.target.id.substring(0,3);
    pyrame.sendcmd(return_get_el,null,rundb_port,"get_run_rundb",rundb_view_id);
  }
  if (e.target.id.lastIndexOf("run_g-",0) === 0) {
    rundb_view_id=e.target.id.substring(6);
    rundb_view_type=e.target.id.substring(0,5);
    pyrame.sendcmd(return_get_el,null,rundb_port,"get_run_group_rundb",rundb_view_id);
  }
});


/* Delete element */
document.getElementById("acq_delete").addEventListener("click",delete_el);
document.getElementById("run_delete").addEventListener("click",delete_el);
document.getElementById("run_g_delete").addEventListener("click",delete_el);
function delete_el() {
  function return_del(retcode,res) {
    if (retcode=="0") {
      add_to_error_log(res,1);
      return;
    }
    document.getElementById("rundb-"+rundb_view_type+"-data").style.display="none";
    rundb_view_id=null;
    rundb_view_type=null;
    update_rundb_browser();
  }
  var confirmed=confirm("Are you sure you want to DELETE "+rundb_view_id+"?\nNote that deletion only affects the RunDB. Files must be manually removed.");
  if (confirmed) {
    switch (rundb_view_type) {
      case "acq":
        pyrame.sendcmd(return_del,null,rundb_port,"del_acq_rundb",rundb_view_id);
        return;
      case "run":
        pyrame.sendcmd(return_del,null,rundb_port,"del_run_rundb",rundb_view_id,"1");
        return;
      case "run_g":
        pyrame.sendcmd(return_del,null,rundb_port,"del_run_group_rundb",rundb_view_id,"1");
        return;
    }
  }
}


/* search */ 
document.getElementById("rundb-search").addEventListener("click", function() {

  function return_search(retcode,res) {
    if (retcode=="0") {
      add_to_error_log(res,1);
      return;
    }
    var params=atob(res).split("\n");
    var table="<tr><th>Acquisition</th><th>Parameter</th><th>Value</th></tr>";
    for (var i=0;i<params.length;i++) {
      var param=params[i].split("\t");
      table+="<tr><td id=\"acq_found-"+param[0]+"-"+param[1]+"\"></td><td>"+param[1]+"</td><td>"+param[2]+"</td></tr>";
    }
    document.getElementById("rundb-search-results").innerHTML=table;
    for (var i=0;i<params.length;i++) {
      var param=params[i].split("\t");
      document.getElementById("acq_found-"+param[0]+"-"+param[1]).innerHTML=param[0];
    }
  }
  var key_regex=document.getElementById("rundb-search-param1").value;
  var value_regex=document.getElementById("rundb-search-value1").value;
  pyrame.sendcmd(return_search,null,rundb_port,"get_acqs_table_regex_rundb",key_regex,value_regex);
});
