/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Calicoes.
*/

/* Get API from module_name on port_string */
function getapi(port_string,module_name) {
  function return_getapi(retcode,res) {
    if (retcode=="1") {
      apipool.add_api_from_string(module_name,res);
    } else add_to_error_log(res,1);
  }
  pyrame.sendcmd(return_getapi,null,port_string,"getapi_"+module_name);
}


/* Dialog function */
function dialog(msg,args,f_ok,f_ok_args,f_cancel,f_cancel_args) {
  document.getElementById("dialog_bg").style.display="table";
  document.getElementById("dialog_info").innerHTML=msg;
  document.getElementById("dialog_prompts").innerHTML="";
  for (var i=0;i<args.length;i++) {
    var entry = "<p>" + args[i] + ": <input type=\"text\" id=\"dialog_prompt_" + args[i] + "\" value=\""
    if (default_params[args[i]]) {
      entry += default_params[args[i]]
    }
    document.getElementById("dialog_prompts").innerHTML += entry+"\"></p>";
  }
  document.getElementById("dialog_prompt_" + args[0]).focus();
  document.getElementById("dialog_ok").onclick=function(e) {
    document.getElementById("dialog_bg").style.display="none";
    f_ok(f_ok_args);
  }
  document.getElementById("dialog_cancel").onclick=function(e) {
    document.getElementById("dialog_bg").style.display="none";
    f_cancel(f_cancel_args);
  }
}


/* Get list of files and put them in a drop box list */
function return_get_file_list(retcode,res,list_id,depth,sort,callback) {
  if (retcode=="0") {
    add_to_error_log(res,1);
    return;
  }
  var file_list_e=document.getElementById(list_id);
  file_list_e.innerHTML="";
  var choose_file_e=document.createElement("option");
  choose_file_e.text="Choose a file";
  choose_file_e.value="None";
  file_list_e.add(choose_file_e);
  var file_list=res.split(",");
  if (sort) {
    file_list.sort();
  }
  for (var i=0;i<file_list.length;i++) {
    var choice_e=document.createElement("option");
    var file_exp=file_list[i].split("/");
    for (var j=0;j<depth;j++) {
      // Remove the first *depth* levels of the path
      file_exp.shift();
    }
    var choice=file_exp.join("/");
    // If there's a dot in choice, remove extension
    if (choice.lastIndexOf(".")!=-1) {
      choice=choice.substring(0,choice.lastIndexOf("."));
    }
    choice_e.text=choice;
    choice_e.value=file_list[i];
    file_list_e.add(choice_e);
  }
  if (callback) {
    callback();
  }
}

