/// \file
/// \ingroup tutorial_tree
/// \notebook -nodraw
///  Read data from an ascii file and create a root file with an histogram and an ntuple.
///  See a variant of this macro in basic2.C.
///
/// \macro_code
///
/// \author Rene Brun

#include "Riostream.h"
#include "TString.h"
#include "TGraph.h"
#include "TDatime.h"
#include "TCanvas.h"

using namespace std;

void hvfinal() {


  auto *c1 = new TCanvas("c1","c1",0,0,1000,600);
  c1->cd();
  

  TFile *f = TFile::Open("/home/data/hv-2017-04-10_09_58_22.root");
  f->cd();

  TGraph* graph = (TGraph*) f-> Get("hv_graph");

  graph->SetMarkerStyle(20);
  graph->GetXaxis()->SetTimeDisplay(1);
  graph->GetXaxis()->SetNdivisions(-504);
  graph->GetXaxis()->SetTimeFormat("%d %H:%M:%S");
  graph->GetYaxis()->SetTitle("uA");
  graph->GetXaxis()->SetTimeOffset(0,"local");
  graph->Draw("ap");
    
  f->Close();
}
