#!/usr/bin/env python2
# -*- coding: utf-8 -*-
#
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy, LLR
#

import sys,time,os,datetime
import bindpyrame

execfile("config.py")

# OUTPUT FILE
output=open(monitor_logfile,"w",0)

# BINDPYRAME
ps_port=bindpyrame.get_port("PS_PORT")
mm_port=bindpyrame.get_port("MULTIMETER_PORT")

# CONF STRINGS
ps_cs="%s(bus=gpib(bus=tcp(host=%s),dst_addr=%s))"%(model,device_ip,gpib_addr)
mm_cs="mm_%s(bus=gpib(bus=tcp(host=%s),dst_addr=%s))"%(model,device_ip,gpib_addr)

# MAIN
while True:
    future=datetime.datetime.now()+datetime.timedelta(seconds=monitor_refresh_time)
    retcode,res=bindpyrame.sendcmd(host,mm_port,"get_dc_current_multimeter",mm_id,monitor_I_range,monitor_I_res)
    if retcode==0:
        print("Error getting DC current <- %s"%(res))
        continue
    now_str=str(datetime.datetime.now().strftime("%Y/%m/%d %H:%M:%S"))
    print("%s: %e A"%(now_str,float(res)))
    output.write("%s: %e A\n"%(now_str,float(res)))
    if abs(float(res))>monitor_I_limit:
        print("#############################################")
        print("current %.6e above specified limit of %.6e"%(float(res),monitor_I_limit))
    now=datetime.datetime.now()
    wait_time=(future-now).total_seconds()
    if wait_time<0:
        wait_time=0
    time.sleep(wait_time)
