#include "lcio.h"

#include "IO/LCWriter.h"
#include "EVENT/LCIO.h"
#include "DATA/LCFloatVec.h"
#include "DATA/LCIntVec.h"

#include "IMPL/LCEventImpl.h" 
#include "IMPL/LCRunHeaderImpl.h" 
#include "IMPL/LCCollectionVec.h"
#include "IMPL/CalorimeterHitImpl.h"
#include "IMPL/SimTrackerHitImpl.h"
#include "IMPL/MCParticleImpl.h" 
//#include "IMPL/LCFlagImpl.h" 
#include "IMPL/LCTOOLS.h"

#include "IMPL/TrackerRawDataImpl.h"
#include "IMPL/TrackerDataImpl.h"
#include "IMPL/TrackerPulseImpl.h"

#include "UTIL/LCRelationNavigator.h"
#include "UTIL/LCTime.h"
//#include "UTIL/BitField64.h"
#include "UTIL/CellIDEncoder.h"
#include "UTIL/LCTypedVector.h"
#include "UTIL/LCSplitWriter.h"
#include "UTIL/BitSet32.h"

#include <cstdlib>
#include <iostream>
#include <sstream>



using namespace std ;
using namespace lcio ;

int main() {
  float pos[3];
  LCWriter* lcWriter=LCFactory::getInstance()->createLCWriter();
  lcWriter->open("test.slcio",LCIO::WRITE_NEW);
  for (int i=0;i<1;i++) {
    LCEventImpl* evt=new LCEventImpl(); // create the event 
    evt->setRunNumber(0);
    evt->setEventNumber(i); // set the event attributes
    LCCollectionVec* calVec=new LCCollectionVec(LCIO::CALORIMETERHIT);
    for(int j=0;j<10;j++){
      CalorimeterHitImpl* hit=new CalorimeterHitImpl;
      hit->setCellID0(12345);      //int
      hit->setCellID1(67890);      //int
      hit->setEnergy(3.1415);      //float
      hit->setEnergyError(0.0001); //float
      hit->setTime(2.7182);        //float
      pos[0]=1.0;
      pos[1]=4.5;
      pos[2]=0.0;
      hit->setPosition(pos);       //float[3]
      hit->setType(1);             //int codage inconnu???
      calVec->push_back(hit); // add hit objects to the collection
    }
    evt->addCollection(calVec,"HCalPPTHits"); // add the collection with a name
    lcWriter->writeEvent(evt); // write the event to the file
    delete evt;
  }
  lcWriter->close();
}
