#!/usr/bin/env python2
# -*- coding: utf-8 -*-
#
# Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
#

import sys

def split_bin(n,size):
        """translate an integer in binary string"""
        res=""
        for _ in range(size):
                q=n//2
                r=n%2
                res=str(r)+res
                n=q
        return res

def bin2hexa(binstr):
        """convert a binary string in hexadecimal"""
        result=""
        extstr=binstr
        #extend string with 0 for having a size multiple of 4
        for i in range(len(binstr)%4):
                extstr="0"+extstr
        for i in range(len(extstr)/4):
                lbs=extstr[i*4:i*4+4]
                intv=int(lbs,2)
                result=result+"%x"%(intv)
        return result

fbcap_strings=["0pF","0.4pF","0.8pF","1.2pF","1.6pF","2pF","2.4pF","2.8pF","3.2pF","3.6pF","4pF","4.4pF","4.8pF","5.2pF","5.6pF","6pF"]
cpcap_strings=["0pF","1pF","2pF","3pF","4pF","5.pF","6pF","7pF"]

hexabt=sys.argv[1]
print("bitstream=%s"%(hexabt))

bitstream=""
for i in range(len(hexabt)):
    c=hexabt[i]
    bitstream=bitstream+split_bin(int(c,16),4)

print("binary bitstream : ")
print(bitstream)

print("channel preamp   cal capa leak trig")
for channel in range(64):
    if bitstream[417+(63-channel)*3]=="0":
        print_preamp="enabled"
    else:
        print_preamp="disabled"
    if bitstream[416 +(63-channel)*3]=="0":
        print_cal_capa="disabled"
    else:
        print_cal_capa="enabled"
    if bitstream[415+(63-channel)*3]=="0":
        print_leak="low"
    else:
        print_leak="high"
    if bitstream[73+channel]=="0":
        print_trig="allowed"
    else:
        print_trig="masked"
    print_dacadj=bitstream[137+channel:141+channel]
    print("{0:<8d}{1:9s}{2:9s}{3:5s}{4:8s}".format(channel,print_preamp,print_cal_capa,print_leak,print_trig))

chipid=bitstream[10:18]
print("Chipid in gray : %s"%(chipid))
    
bdelay=bitstream[63:71]
#print("binary delay : %s"%(bdelay))
delay=bin2hexa(bdelay[::-1])
idelay=int("0x"+delay,16)
print("Delay for the trigger signals : %d(0x%s)"%(idelay,delay))
    
btrig=bitstream[41:51]
#print("binary trigth : %s"%(btrig))
trig=bin2hexa(btrig[::-1])
itrig=int("0x"+trig,16)
print("Trigger Threshold : %d(0x%s) "%(itrig,trig))


bfbcap=bitstream[607:611]
fbcap=bin2hexa(bfbcap[::-1])
ifbcap=int("0x"+fbcap,16)
print("Feedback capacitance : %d(0x%s) value=%s "%(ifbcap,fbcap,fbcap_strings[ifbcap]))

#bcpcap=bitstream[611:614]
#cpcap=bin2hexa(bcpcap[::-1])
#icpcap=int("0x"+cpcap,16)
#print("Compensation capacitance : %d(0x%s) value=%s "%(icpcap,cpcap,cpcap_strings[icpcap]))

if bitstream[9]=="0":
    print("Internal trigger")
else:
    print("External trigger only")
        
