#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import os,time

unit=0
max_i=1
i=0
finished=0

def basic_find_noisy_init():
    declare_param("run_name","name of run","basic_find_noisy")
    declare_param("noise_thr","noise threshold",0.01)
    declare_param("max_iter","maximum number of iterations",1)
    declare_param("trigger_thr","target trigger threshold",240)
    declare_param("wait","number of noise level hits or acquisition time per point (s)",1)
    declare_param("fn_type","type of find noisy: noise_thr or timed","timed")
  
def basic_find_noisy_run(run_name,noise_thr,max_iter,trigger_thr,wait,fn_type):
    global finished
    finished=0
    configure()
    calib=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
    nt=float(noise_thr)
    global max_i
    max_i=int(max_iter)
    tt=int(trigger_thr)
    if fn_type=="noise_thr":
        # nb of spills to acquire (each spill has a max of 15 hits per channel):
        await=float(wait)*2/(15*nt) # 15 columns usually half-filled
        unit="hits"
    elif fn_type=="timed":
        await=int(wait)
        unit="s"
    else:
        raise Exception("invalid type of find noisy")
    run=new_run("%s/T%d_%.2f_%s%s"%(run_name,tt,nt,wait,unit))
    new_cmd_path=""
    nb_dif=len(list_dev("dif","root"))
    for roc in list_dev("skiroc","root"):
        chipid = int(roc.split("_")[-1])-1
        reconfigure(roc,'set_gtrigger_skiroc',str(tt+calib[chipid]))
    global i
    for i in range(max_i):
        #acquisition
        print("#############################################")
        print("## THRESHOLDS: TRIGGER %3d ; NOISE %.3f ####"%(tt,nt))
        print("############## ITERATION %3d ################"%(i))
        print("#############################################")
        if fn_type=="noise_thr":
            acq=nb_spills_acq("%d/noisy"%(i),run,await)
        elif fn_type=="timed":
            acq=timed_acq("%d/noisy"%(i),run,await)
        wait_acq_finished(acq)
        for dif in list_dev("dif","root"):
            difid=dif.lstrip("dif_")
            cumul_cmd_path="%s/AnalyseCalib_T%d_%s.cmd"%(run["path"],tt,dif)
            rc_exec("rm -f %s"%(cumul_cmd_path))
            #data conversion
            #time.sleep(0.5)
            rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s/noisy_%s.raw\\\",true,false\)"%(acq["path"],dif))
            #analyse
            #time.sleep(0.5)
            rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/RunFindNoisyN.cc\(\\\"%s/noisy_%s.raw.root\\\",%d,%f,\\\"%s\\\"\)"%(acq["path"],dif,i,nt,difid))
            #run the reconfigure command file
            new_cmd_path = "%s/AnalyseCalib_T%d_%d_%s.cmd"%(acq["path"],tt,i,dif)
            rc_exec("cp /tmp/AnalyseCalib.cmd %s"%(new_cmd_path))
            #time.sleep(0.5)
            rc_exec("cat %s >> %s"%(new_cmd_path,cumul_cmd_path))
            #time.sleep(0.5)
            rc_exec("cp /tmp/FindNoisy%s.root %s/FindNoisy_T%d_%d_%s.root"%(difid,acq["path"],tt,i,dif))
            run_cmdfile("/tmp/AnalyseCalib.cmd")
    finished=1
    return cumul_cmd_path

def basic_find_noisy_get_progress():
    return int((float(progress_acq)*0.99 + finished + 100.0*i)/max_i)

execfile("/opt/calicoes/pycaldaq_rcs.py")
