#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import time,sys,os,datetime

tt_mn=0
tt_list=[]
tt=0
pc=0
final=False

def mask_noisy_init():
    declare_param("run_name","name of run","masknoisy/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trigger_thr_mn","trigger threshold goal for mask noisy",240)
    declare_param("trigger_step_mn","trigger threshold step for mask noisy",5)
    declare_param("percent_mn","noise threshold goal (%)","1")

def mask_noisy_run(run_name,trigger_thr_mn,trigger_step_mn,percent_mn):
    global tt_mn
    tt_mn=int(trigger_thr_mn)
    step_mn=int(trigger_step_mn)
    pc_mn=float(percent_mn)/100

    configure()

    #########  Remove Trigger Noise  ############
    difs = list_dev("dif","root")
    for dif in difs:
        reconfigure(dif,"set_dif_mode_dif","ILC")
    reconfigure("spill","set_high_level_signal","4.0")
    reconfigure("spill","set_low_level_signal","0.0")
    reconfigure("spill","set_pulse_width_signal","0.01")
    reconfigure("spill","set_edges_signal","100e-9","100e-9")
    reconfigure("spill","set_delay_signal","0.0")
    reconfigure("spill","set_frequency_signal","2.0") 

    # allow all channels and set delay
    for roc in list_dev("skiroc","root"): 
        reconfigure(roc,"allow_trig_chans_skiroc","all")
        reconfigure(roc,"set_delay_skiroc","120")       

    # mns decreasing trigger threshold (tt)
    global final
    final=False
    global tt_list
    tt_list=[tt_mn+10*step_mn]
    tt_list+=range(tt_mn+2*step_mn,tt_mn-1*step_mn,-1*step_mn)
    global tt
    for tt in tt_list:
        print("trigger threshold: %d"%tt)
        global pc_list
        pc_list=[pc_mn*10,pc_mn]
        global pc
        for pc in pc_list:
            print basic_find_noisy_run(run_name,pc,1,tt,100,"noise_thr")

    final=True
    # final mn
    tt=tt_mn
    print("final trigger threshold: %d"%tt)
    print basic_find_noisy_run(run_name,pc_mn,1,tt,1000,"noise_thr")

def mask_noisy_get_progress():
    progress=basic_find_noisy_get_progress()
    if final and progress==100:
        return 100
    if tt in tt_list:
        if not final:
            return (100.0*tt_list.index(tt)+(100.0*pc_list.index(pc)+progress%100)/(len(pc_list)))*1.1/(1.1*len(tt_list)+10)
        else:
            return (100.0*len(tt_list)*1.1+(progress%100)*10)/(1.1*len(tt_list)+10)

execfile("/opt/pyrame/rc_scripts/standard/basic_find_noisy.py")
