#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import os,base64

def normal_run_init():
    declare_param("shifter","Name of shifter","")
    declare_param("beam_nature","Beam nature","cosmic")
    declare_param("beam_energy","Beam energy","0")
    declare_param("comment","Comment","")

def normal_run_run(shifter,beam_nature,beam_energy,comment):

    if shifter=="":
        raise Exception("The shifter parameter is required")

    configure()

    #read previous run_nb
    run_nb_filename="/opt/calicoes/config/runid.txt"
    if not os.path.exists(run_nb_filename):
        run_nb_file=open(run_nb_filename,"w")
        run_nb_file.write("0")
        run_nb_file.close()
    run_nb_file=open(run_nb_filename,"r")
    prev_run_nb=int(run_nb_file.read())
    run_nb_file.close()

    #calculate current run_nb
    raw_run_nb=prev_run_nb+1
    run_nb="%04d"%(raw_run_nb)

    #update the runid file
    run_nb_file=open(run_nb_filename,"w")
    run_nb_file.write(run_nb)
    run_nb_file.close()

    #set run and acq names
    run_name="calicoes/run_%s"%(run_nb)
    acq_name="run_%s"%(run_nb)

    #start the run
    run=new_run(run_name)
    acq=new_acq(acq_name,run)

    #create a start message
    msg="%s started\n"%(run_name)
    msg+="Data available at %s\n"%(acq["acq_path"])
    msg+="Shifter: %s\n"%(shifter)
    msg+="Beam nature: %s\n"%(beam_nature)
    msg+="Beam energy: %s\n"%(beam_energy)
    if comment!="":
        msg+="Comment: %s\n"%(comment)
    msg64=base64.b64encode(msg)

    set_param_run(run,"shifter",shifter)
    set_param_run(run,"beam_nature",beam_nature)
    set_param_run(run,"beam_energy",beam_energy)
    set_param_run(run,"comment",comment)

    start_acq(acq)
    try:
        while True:
            int_sleep(500)
    except:
        pass
    stop_acq()

    #create a stop message
    msg="%s stopped"%(run_name)
    msg+="Data available at %s"%(run["path"])
    msg64=base64.b64encode(msg)

execfile("/opt/calicoes/pycaldaq_rcs.py")
