#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import time,sys,os,datetime

def regular_test_init():
    declare_param("run_group","name of run","regular_tests/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trigger_thr_mn","trigger threshold goal for mask noisy and for final acq",230)
    declare_param("trigger_step_mn","trigger threshold step for mask noisy",10)
    declare_param("percent_mn","noise threshold goal for mask noisy (%)","1")
    declare_param("trigger_max_sc","maximum trigger threshold for scurves",240)
    declare_param("trigger_min_sc","minimum trigger threshold for scurves",180)
    declare_param("trigger_step_sc","step of scurves",5)
    declare_param("acq_time_sc","acquisition time for scurves per step (s)",180)
    declare_param("acq_time","acquisition time for final acquisition (min)",60)

def regular_test_run(run_group,trigger_thr_mn,trigger_step_mn,percent_mn,trigger_max_sc,trigger_min_sc,trigger_step_sc,acq_time_sc,acq_time):

    configure()

    ###########################
    ## SCURVES
    ###########################

    run_name="%s/scurves"%(run_group)
    timed_scurves_allby8_run(run_name,trigger_min_sc,trigger_max_sc,trigger_step_sc,acq_time_sc)

    ##########################
    # MASK NOISY
    ##########################

    run_name="%s/masknoisy"%(run_group)
    mask_noisy_run(run_name,trigger_thr_mn,trigger_step_mn,percent_mn)


    ##########################
    # ACQUISITION
    ###########################

    run=new_run("%s/cosm"%(run_group))

    for roc in list_dev("skiroc","root"):
        chipid=int(roc.split("_")[-1])-1
        reconfigure(roc,"set_gtrigger_skiroc",str(trigger_thr_mn))
    for dif in list_dev("dif","root"):
        reconfigure(dif,"set_dif_mode_dif","BT")
    reconfigure("spill","set_high_level_signal","4.0")
    reconfigure("spill","set_low_level_signal","0.0")
    reconfigure("spill","set_pulse_width_signal","0.06")
    reconfigure("spill","set_edges_signal","100e-9","100e-9")
    reconfigure("spill","set_delay_signal","0.0")
    reconfigure("spill","set_frequency_signal","10.0") 

    acq=timed_acq("%s_minutes"%(acq_time),run,float(acq_time)*60)

    rc_exec("/opt/root/bin/root -l -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s_by_dif0.raw\\\",true,true\)"%(acq["id"]))

start_script=False
execfile("/opt/pyrame/rc_scripts/standard/mask_noisy.py")
start_script=True
execfile("/opt/pyrame/rc_scripts/standard/timed_scurves_allby8.py")
