#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import time,sys,os,datetime
progress=0

def timed_find_noisy_init():
    declare_param("run_name","name of run","findnoisy/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trigger_thr_fn","trigger threshold goal for find noisy",240)
    declare_param("trigger_step_fn","trigger threshold step for find noisy",5)
    declare_param("acq_time_fn","acquisition time for find noisy per step (s)",180)
    declare_param("acq_time_final_fn","final acquisition time for find noisy (s)",300)

def timed_find_noisy_run(run_name,trigger_thr_fn,trigger_step_fn,acq_time_fn,acq_time_final_fn):
    global progress

    tt_fn=int(trigger_thr_fn)
    step_fn=int(trigger_step_fn)
    time_fn=float(acq_time_fn)
    time_final_fn=float(acq_time_final_fn)

    progress=0

    configure()

    #########  Remove Trigger Noise  ############
    difs = list_dev("dif","root")
    for dif in difs:
        reconfigure(dif,"set_dif_mode_dif","ILC")
    reconfigure("spill","set_high_level_signal","4.0")
    reconfigure("spill","set_low_level_signal","0.0")
    reconfigure("spill","set_pulse_width_signal","0.01")
    reconfigure("spill","set_edges_signal","100e-9","100e-9")
    reconfigure("spill","set_delay_signal","0.0")
    reconfigure("spill","set_frequency_signal","2.0") 

    # allow all channels and set delay
    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"allow_trig_chans_skiroc","all")
        reconfigure(roc,"set_delay_skiroc","120")       

    # fns decreasing trigger threshold (tt)
    tt_list=[tt_fn+10*step_fn]
    tt_list+=range(tt_fn+2*step_fn,tt_fn-1*step_fn,-1*step_fn)
    i=1
    for tt in tt_list:
        print("trigger threshold: %d"%tt)
        print basic_find_noisy_run(run_name,0.1,1,tt,time_fn,"timed")
        print basic_find_noisy_run(run_name,0.01,1,tt,time_fn,"timed")
        i+=1
        progress=100*float(i)/float(len(tt_list)+1)

    # final fn
    tt=tt_fn
    print("final trigger threshold: %d"%tt)
    print basic_find_noisy_run(run_name,0.01,1,tt,time_final_fn,"timed")
    progress=100

def timed_find_noisy_get_progress():
    global progress
    return progress

execfile("/opt/pyrame/rc_scripts/standard/basic_find_noisy.py")
