#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import datetime

tt_step=0
tt_max=1
tt_min=0
chan=0

def timed_scurves_allby8_init():
    declare_param("run_name","name of run","scurves/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trig_min","minimum trigger threshold","180")
    declare_param("trig_max","maximum trigger threshold","240")
    declare_param("trig_step","trigger threshold step","5")
    declare_param("acq_time","acquisition time per step (s)","180")

def timed_scurves_allby8_run(run_name,trig_min,trig_max,trig_step,acq_time):
    global tt_max,tt_min,tt_step
    tt_min=int(trig_min)
    tt_max=int(trig_max)
    tt_step=int(trig_step)
    a_time=int(acq_time)
    
    configure()
    run=new_run(run_name)

    chan_offsets=range(0,63,8) #every 8
    global chan
    for chan in range(8): # every 8
        print("channel x+%d"%(chan))
        for roc in list_dev("skiroc","root"):
            reconfigure(roc,"disallow_trig_chans_skiroc","all")
            for chan_offset in chan_offsets:
                reconfigure(roc,"allow_trig_chans_skiroc",str(chan+chan_offset))
        acq=timed_scurves("%d"%(chan*8),run,tt_max,tt_min,tt_step,a_time,"skiroc")
        wait_acq_finished(acq)
        # data conversion
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertDirectory.cc\(\\\"%s/\\\"\)"%(acq["path"]))
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/RunMerge4Scurves.cc\(\\\"%s/\\\",%d,%d,%d\)"%(acq["path"],tt_min,tt_max,tt_step))

    # final data conversion
    rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/RunMergeByN.cc\(\\\"%s/\\\",true,8,%d,%d,%d\)"%(run["path"],tt_min,tt_max,tt_step))

def timed_scurves_allby8_get_progress():
    if progress_trig_scurves==100:
        if chan==7:
            return 100
        else:
            return float(chan)/8*100+progress_trig_scurves/8
    return float(chan)/8*100+(progress_trig_scurves+progress_acq*tt_step/float(abs(tt_max-tt_min)))/8

execfile("/opt/calicoes/pycaldaq_rcs.py")
