#!/usr/bin/env python2
# -*- coding: utf-8 -*-
#

import time,sys,os,datetime

def Commissioning1_init():
    declare_param("run_group","name of run","BTJune2017_preparation/slabXX")
    declare_param("trigger_thr_fn","trigger threshold goal for find noisy",225)
    declare_param("trigger_step_fn","trigger threshold step for find noisy",5)
    declare_param("acq_time_fn","acquisition time for find noisy per step (s)",30)
    declare_param("acq_time_final_fn","final acquisition time for find noisy (s)",45)
    declare_param("trigger_max_sc","maximum trigger threshold for scurves",270)
    declare_param("trigger_min_sc","minimum trigger threshold for scurves",170)
    declare_param("trigger_step_sc","step of scurves",5)


def Commissioning1_run(run_group,trigger_thr_fn,trigger_step_fn,acq_time_fn,acq_time_final_fn,trigger_max_sc,trigger_min_sc,trigger_step_sc):

    configure()

    ## ------------------------------------------------------
    for dif in list_dev("dif","root"):
        reconfigure(dif,"set_dif_mode_dif","BT")

    spill_lenght_final=5.
    spillwidth=0.001*float(spill_lenght_final)
    spillfreq=4
    reconfigure("spill","set_pulse_width_signal",str(spillwidth))
    reconfigure("spill","set_frequency_signal",str(spillfreq))
       
    ## --------------------------------------------------------------------------------
    ## FIND NOISY 
    ## --------------------------------------------------------------------------------

    run_name="%s/findnoisy_%sHz_%sms_1_1_0.05_0.01"%(run_group,str(spillfreq),str(spill_lenght_final))

    # mask ADC= 4 channels
    rocN=0
    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"allow_trig_chans_skiroc","all")
        reconfigure(roc,"enable_preamp_chans_skiroc","all")
        reconfigure(roc,"disable_preamp_chans_skiroc","37")
        reconfigure(roc,"disallow_trig_chans_skiroc","37")
        reconfigure(roc,"set_gtrigger_skiroc",str(230))
        reconfigure(roc,"set_delay_skiroc",int(150))
        if rocN==1 or rocN==9:
            #preamp
            reconfigure(roc,"disable_preamp_chans_skiroc","41")
            reconfigure(roc,"disable_preamp_chans_skiroc","42")
            reconfigure(roc,"disable_preamp_chans_skiroc","43")
            reconfigure(roc,"disable_preamp_chans_skiroc","44")
            reconfigure(roc,"disable_preamp_chans_skiroc","45")
            reconfigure(roc,"disable_preamp_chans_skiroc","46")
            reconfigure(roc,"disable_preamp_chans_skiroc","47")
            reconfigure(roc,"disallow_trig_chans_skiroc","41")
            reconfigure(roc,"disallow_trig_chans_skiroc","42")
            reconfigure(roc,"disallow_trig_chans_skiroc","43")
            reconfigure(roc,"disallow_trig_chans_skiroc","44")
            reconfigure(roc,"disallow_trig_chans_skiroc","45")
            reconfigure(roc,"disallow_trig_chans_skiroc","46")
            reconfigure(roc,"disallow_trig_chans_skiroc","47")
            print("roc=%s"%(roc))
        if rocN==0 or rocN==8:
            reconfigure(roc,"disable_preamp_chans_skiroc","5")
            reconfigure(roc,"disallow_trig_chans_skiroc","5")
        if rocN==7 or rocN==15:
            reconfigure(roc,"disable_preamp_chans_skiroc","3")
            reconfigure(roc,"disallow_trig_chans_skiroc","3")
            reconfigure(roc,"disable_preamp_chans_skiroc","9")
            reconfigure(roc,"disallow_trig_chans_skiroc","9")
            reconfigure(roc,"disable_preamp_chans_skiroc","10")
            reconfigure(roc,"disallow_trig_chans_skiroc","10")
        if (rocN==9 or rocN==1):
            reconfigure(roc,"disable_preamp_chans_skiroc","48-53")
            reconfigure(roc,"disallow_trig_chans_skiroc","48-53")
        rocN=rocN+1
        if rocN==16:
            rocN=0
  
    timed_find_noisy_scan_run(run_name,trigger_thr_fn,trigger_step_fn,acq_time_fn,acq_time_final_fn,spill_lenght_final,1,1,0.05,0.01)
    rc_exec("cat /home/data/prototech/%s/*/*/*cmd | grep reconfigure >  /home/data/prototech/%s/MaskedChannels.cmd"%(run_name,run_group))

    #run_cmdfile("/home/data/prototech/%s/MaskedChannels.cmd"%(run_group))

    ## --------------------------------------------------------------------------------
    ## SCURVES, all ennabled, no channel injection
    ## --------------------------------------------------------------------------------
    run_name="%s/scurves_64_%sHz_%sms_masked"%(run_group,str(spillfreq),str(spill_lenght_final))
    run=new_run(run_name)
    acq=timed_scurves("0",run,int(trigger_max_sc),int(trigger_min_sc),int(trigger_step_sc),float(20),"skiroc")
    rc_exec("/opt/root/bin/root -l -q /opt/calicoes/standard/ConvertDirectory.cc\(\\\"%s/0/\\\"\)"%(run["path"]))
    rc_exec("/home/calice/tpecal/bin/tpecalana %s/0/ %s scurves 16 0 0 %s &"%(run["path"],run["path"],dif))

start_script=True
execfile("/opt/pyrame/rc_scripts/user/commissioning/timed_find_noisy_scan.py")
