#!/usr/bin/env python2
# -*- coding: utf-8 -*-
#

import time,sys,os,datetime

def Commissioning_cosmics_init():
    declare_param("run_group","name of run","BTJune2017_preparation/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trigger_thr_fn","trigger threshold goal for find noisy",230)
    declare_param("trigger_step_fn","trigger threshold step for find noisy",5)
    declare_param("acq_time_fn","acquisition time for find noisy per step (s)",20)
    declare_param("acq_time_final_fn","final acquisition time for find noisy (s)",30)
    declare_param("trigger_max_sc","maximum trigger threshold for scurves",270)
    declare_param("trigger_min_sc","minimum trigger threshold for scurves",170)
    declare_param("trigger_step_sc","step of scurves",5)
    declare_param("acq_time_sc","acquisition time for scurves per step (s)",30)


def Commissioning_cosmics_run(run_group,trigger_thr_fn,trigger_step_fn,acq_time_fn,acq_time_final_fn,trigger_max_sc,trigger_min_sc,trigger_step_sc,acq_time_sc):

    configure()

    #time.sleep(60)

    ## ------------------------------------------------------
    for dif in list_dev("dif","root"):
        reconfigure(dif,"set_dif_mode_dif","BT")
 
    # mask ADC= 4 channels
    rocN=0
    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"allow_trig_chans_skiroc","all")
        reconfigure(roc,"enable_preamp_chans_skiroc","all")
        reconfigure(roc,"disable_preamp_chans_skiroc","37")
        reconfigure(roc,"disallow_trig_chans_skiroc","37")
        reconfigure(roc,"set_delay_skiroc",int(150))
        if rocN==1 or rocN==9:
            #preamp
            reconfigure(roc,"disable_preamp_chans_skiroc","41")
            reconfigure(roc,"disable_preamp_chans_skiroc","42")
            reconfigure(roc,"disable_preamp_chans_skiroc","43")
            reconfigure(roc,"disable_preamp_chans_skiroc","44")
            reconfigure(roc,"disable_preamp_chans_skiroc","45")
            reconfigure(roc,"disable_preamp_chans_skiroc","46")
            reconfigure(roc,"disable_preamp_chans_skiroc","47")
            reconfigure(roc,"disallow_trig_chans_skiroc","41")
            reconfigure(roc,"disallow_trig_chans_skiroc","42")
            reconfigure(roc,"disallow_trig_chans_skiroc","43")
            reconfigure(roc,"disallow_trig_chans_skiroc","44")
            reconfigure(roc,"disallow_trig_chans_skiroc","45")
            reconfigure(roc,"disallow_trig_chans_skiroc","46")
            reconfigure(roc,"disallow_trig_chans_skiroc","47")
            print("roc=%s"%(roc))
        if rocN==0 or rocN==8:
            reconfigure(roc,"disable_preamp_chans_skiroc","5")
            reconfigure(roc,"disallow_trig_chans_skiroc","5")
        if rocN==7 or rocN==15:
            reconfigure(roc,"disable_preamp_chans_skiroc","3")
            reconfigure(roc,"disallow_trig_chans_skiroc","3")
            reconfigure(roc,"disable_preamp_chans_skiroc","9")
            reconfigure(roc,"disallow_trig_chans_skiroc","9")
            reconfigure(roc,"disable_preamp_chans_skiroc","10")
            reconfigure(roc,"disallow_trig_chans_skiroc","10")
        if (rocN==9 or rocN==1):
            reconfigure(roc,"disable_preamp_chans_skiroc","48-53")
            reconfigure(roc,"disallow_trig_chans_skiroc","48-53")
        rocN=rocN+1
        if rocN==16:
            rocN=0

    run_cmdfile("/home/data/prototech/%s/MaskedChannels.cmd"%(run_group))
    run_cmdfile("/home/data/prototech/%s/scurves_64_4Hz_5.0ms_masked/Scurves_PlaneEvThresh64_buff0_dif_1_1_1_5sigma.cmd"%(run_group))


    ##########################
    # ACQUISITION
    ###########################
    run=new_run("%s/cosmics_5"%(run_group))
    
    spillfreq=4
    spill_lenght_final=150
    spillwidth=0.001*float(spill_lenght_final)
    reconfigure("spill","set_pulse_width_signal",str(spillwidth))
    reconfigure("spill","set_frequency_signal",str(spillfreq))

    acq=timed_acq("cosmicrun_5min_spill4Hz_150ms",run,float(60)*5)
    for dif in list_dev("dif","root"):
        print(acq["path"])
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s/cosmicrun_5min_spill4Hz_150ms_%s.raw\\\",true,false\)"%(acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/cosmicrun_5min_spill4Hz_150ms_%s.raw.root %s/cosmicrun_5min_spill4Hz_150ms_%s.raw MonitorChannel 16 &"%(acq["path"],dif,acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/cosmicrun_5min_spill4Hz_150ms_%s.raw.root %s/cosmicrun_5min_spill4Hz_150ms_%s.raw MonitorChip 16 &"%(acq["path"],dif,acq["path"],dif))

    acq=timed_acq("cosmicrun_1h_spill4Hz_150ms",run,float(60)*60)
    for dif in list_dev("dif","root"):
        print(acq["path"])
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s/cosmicrun_1h_spill4Hz_150ms_%s.raw\\\",true,false\)"%(acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/cosmicrun_1h_spill4Hz_150ms_%s.raw.root %s/cosmicrun_1h_spill4Hz_150ms_%s.raw MonitorChannel 16 &"%(acq["path"],dif,acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/cosmicrun_1h_spill4Hz_150ms_%s.raw.root %s/cosmicrun_1h_spill4Hz_150ms_%s.raw MonitorChip 16 &"%(acq["path"],dif,acq["path"],dif))



start_script=True
execfile("/opt/pyrame/rc_scripts/user/commissioning/timed_find_noisy_scan.py")
