#!/usr/bin/env python2
# -*- coding: utf-8 -*-
#

import time,sys,os,datetime

def commissioning_noise_maskADC4_init():
    declare_param("run_group","name of run","BTJune2017_commissioning/slabXX")
    declare_param("acq_time","acquisition time (s)",60)
    declare_param("runNumber","run Number","1")


def commissioning_noise_maskADC4_run(run_group,acq_time,runNumber):

    configure()

    ## BT mode and spill frequency of 4 Hz, 2.5ms
    ## ------------------------------------------------------
    for dif in list_dev("dif","root"):
        reconfigure(dif,"set_dif_mode_dif","BT")

    spill_lenght_final=5
    spillwidth=0.001*float(spill_lenght_final)
    spillfreq=4
    reconfigure("spill","set_pulse_width_signal",str(spillwidth))
    reconfigure("spill","set_frequency_signal",str(spillfreq))
       
    # mask ADC= 4 channels
    rocN=0
    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"allow_trig_chans_skiroc","all")
        reconfigure(roc,"enable_preamp_chans_skiroc","all")
        reconfigure(roc,"disable_preamp_chans_skiroc","37")
        reconfigure(roc,"disallow_trig_chans_skiroc","37")
        if rocN==1 or rocN==9:
            #preamp
            reconfigure(roc,"disable_preamp_chans_skiroc","41")
            reconfigure(roc,"disable_preamp_chans_skiroc","42")
            reconfigure(roc,"disable_preamp_chans_skiroc","43")
            reconfigure(roc,"disable_preamp_chans_skiroc","44")
            reconfigure(roc,"disable_preamp_chans_skiroc","45")
            reconfigure(roc,"disable_preamp_chans_skiroc","46")
            reconfigure(roc,"disable_preamp_chans_skiroc","47")
            reconfigure(roc,"disallow_trig_chans_skiroc","41")
            reconfigure(roc,"disallow_trig_chans_skiroc","42")
            reconfigure(roc,"disallow_trig_chans_skiroc","43")
            reconfigure(roc,"disallow_trig_chans_skiroc","44")
            reconfigure(roc,"disallow_trig_chans_skiroc","45")
            reconfigure(roc,"disallow_trig_chans_skiroc","46")
            reconfigure(roc,"disallow_trig_chans_skiroc","47")
            print("roc=%s"%(roc))
        if rocN==0 or rocN==8:
            reconfigure(roc,"disable_preamp_chans_skiroc","5")
            reconfigure(roc,"disallow_trig_chans_skiroc","5")
        if rocN==7 or rocN==15:
            reconfigure(roc,"disable_preamp_chans_skiroc","3")
            reconfigure(roc,"disallow_trig_chans_skiroc","3")
            reconfigure(roc,"disable_preamp_chans_skiroc","9")
            reconfigure(roc,"disallow_trig_chans_skiroc","9")
            reconfigure(roc,"disable_preamp_chans_skiroc","10")
            reconfigure(roc,"disallow_trig_chans_skiroc","10")
        if (rocN==9 or rocN==1):
            reconfigure(roc,"disable_preamp_chans_skiroc","48-53")
            reconfigure(roc,"disallow_trig_chans_skiroc","48-53")
        rocN=rocN+1
        if rocN==16:
            rocN=0

    ##########################
    # ACQUISITION
    ###########################
    run=new_run("%s/%s"%(run_group,runNumber))
    
    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"set_gtrigger_skiroc",str(200))
        reconfigure(roc,"set_delay_skiroc",int(150))

    acq=timed_acq("noise_DAC200_hold150",run,float(acq_time))
    for dif in list_dev("dif","root"):
        print(acq["path"])
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s/noise_DAC200_hold150_%s.raw\\\",true,false\)"%(acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/noise_DAC200_hold150_%s.raw.root %s/noise_DAC200_hold150_%s.raw MonitorChip 16 &"%(acq["path"],dif,acq["path"],dif))

    for roc in list_dev("skiroc","root"):
        reconfigure(roc,"set_gtrigger_skiroc",str(230))

    acq=timed_acq("noise_DAC230_hold150",run,float(acq_time))
    for dif in list_dev("dif","root"):
        print(acq["path"])
        rc_exec("/opt/root/bin/root -l -b -q /opt/calicoes/standard/ConvertData.cc\(\\\"%s/noise_DAC230_hold150_%s.raw\\\",true,false\)"%(acq["path"],dif))
        rc_exec("/home/calice/tpecal/bin/tpecalana %s/noise_DAC230_hold150_%s.raw.root %s/noise_DAC230_hold150_%s.raw MonitorChip 16 &"%(acq["path"],dif,acq["path"],dif))


start_script=True
execfile("/opt/pyrame/rc_scripts/user/irles/timed_find_noisy_scan.py")
