#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Calicoes.

import time,sys,os,datetime
progress=0

def timed_find_noisy_scan_init():
    declare_param("run_name","name of run","findnoisy/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S")))
    declare_param("trigger_thr_fn","trigger threshold goal for find noisy",300)
    declare_param("trigger_step_fn","trigger threshold step for find noisy",5)
    declare_param("acq_time_fn","acquisition time for find noisy per step (s)",30)
    declare_param("acq_time_final_fn","final acquisition time for find noisy (s)",50)
    declare_param("spill_lenght_final","final acquisition spill lenght (ms)",20)
    declare_param("spill_lenght_1","factor for the near threshold runs spill lenght (1/x)",2)
    declare_param("spill_lenght_2","factor for the near threshold runs spill lenght (1/x)",10)
    declare_param("noise_th_1","maximum noise level at step 1",0.1)
    declare_param("noise_th_2","maximum noise level at step 2",0.01)


def timed_find_noisy_scan_run(run_name,trigger_thr_fn,trigger_step_fn,acq_time_fn,acq_time_final_fn,spill_lenght_final,spill_lenght_1,spill_lenght_2,noise_th_1,noise_th_2):
    global progress

    tt_fn=int(trigger_thr_fn)
    step_fn=int(trigger_step_fn)
    time_fn=float(acq_time_fn)
    time_final_fn=float(acq_time_final_fn)

    progress=0

    configure()

    # fns decreasing trigger threshold (tt)
    tt_list=[tt_fn+10*step_fn]
    i=1
    spilllenght=0.001*float(spill_lenght_final)/float(spill_lenght_2)
    reconfigure("spill","set_pulse_width_signal",str(spilllenght))
    for tt in tt_list:
        print("trigger threshold: %d"%tt)
        print basic_find_noisy_run(run_name,float(noise_th_1),1,tt,time_fn,"timed")
        print basic_find_noisy_run(run_name,float(noise_th_2),1,tt,time_fn,"timed")
        i+=1
        progress=100*float(i)/float(len(tt_list)+1)

    tt_list=range(tt_fn+2*step_fn,tt_fn-1*step_fn,-1*step_fn)

    spilllenght=0.001*float(spill_lenght_final)/float(spill_lenght_1)
    reconfigure("spill","set_pulse_width_signal",str(spilllenght))
    for tt in tt_list:
        print("trigger threshold: %d"%tt)
        print basic_find_noisy_run(run_name,float(noise_th_1),1,tt,time_fn,"timed")
        print basic_find_noisy_run(run_name,float(noise_th_2),1,tt,time_fn,"timed")      
        i+=1
        progress=100*float(i)/float(len(tt_list)+1)

    # final fn
    tt=tt_fn
    print("final trigger threshold: %d"%tt)
    print basic_find_noisy_run(run_name,float(noise_th_2),1,tt,time_final_fn,"timed")      

    progress=100

def timed_find_noisy_scan_get_progress():
    global progress
    return progress

execfile("/opt/pyrame/rc_scripts/standard/basic_find_noisy.py")
