#!/usr/bin/python2
# -*- coding: utf-8 -*-

def tdc_charge_response_hg_lg_init():
    declare_param("acq_time","Acquisition time (min)","4")
    declare_param("gtrigger","Global trigger threshold","165")
    declare_param("trig_on","Comma-separated list of channels with trigger ON","14")
    declare_param("preamp_on","Comma-separated list of channels with preamp ON","14")
    declare_param("high_gain","High gain preamp value","56")
    declare_param("low_gain","Low gain preamp value","56")
    declare_param("launch_root","Launch analysis in ROOT (ON/OFF)","OFF")

def tdc_charge_response_hg_lg_run(acq_time,gtrigger,trig_on,preamp_on,high_gain,low_gain,launch_root):
    CHIP = "spiroc2d"
    inpDac_on = "0-35" #channel #overwrite
    inputDAC  = "1" #DAC
    date = time.strftime("%Y%m/%d_%H%M")
    print("Date: %s"%(date))
    run_name = "mppc_2D/"+date+"_trig%s"%(gtrigger)
    acq_name = "trig%s"%(gtrigger)

    for roc in list_dev(CHIP,"root"):
	reconfigure(roc,"set_hg_preamp_chans_{0}".format(CHIP),preamp_on,high_gain)
	reconfigure(roc,"set_lg_preamp_chans_{0}".format(CHIP),preamp_on,low_gain)
	reconfigure(roc,"disallow_trig_chans_{0}".format(CHIP),"0-35")
	reconfigure(roc,"allow_trig_chans_{0}".format(CHIP),trig_on)

	reconfigure(roc,"disable_preamp_chans_{0}".format(CHIP),"0-35")
	reconfigure(roc,"enable_preamp_chans_{0}".format(CHIP),preamp_on)

	reconfigure(roc,"disable_input_dac_chans_{0}".format(CHIP),"0-35")
	reconfigure(roc,"enable_input_dac_chans_{0}".format(CHIP),inpDac_on)
	reconfigure(roc,"set_input_dac_chans_{0}".format(CHIP),"0-35",inputDAC)

    for roc in list_dev(CHIP,"root"):
	reconfigure(roc,"set_gtrigger_{0}".format(CHIP),gtrigger)

    print("File name = %s"%(run_name))
    print("Acquisition time = %d sec"%(float(acq_time)*60))
    print("Trigger enabled: ch %s"%(trig_on))
    print("Run with trigger = %s"%(gtrigger))
    print("PreAmp enabled: ch %s"%(preamp_on))
    print("InpurDAC enabled: ch %s"%(inpDac_on))
    print("InpurDAC value = %s"%(inputDAC))
    print("High Gain value = %s"%(high_gain))
    print("Low Gain value = %s"%(low_gain))

    #start the run
    run=new_run(run_name)

    set_param_run(run,"acq_time",acq_time)
    set_param_run(run,"gtrigger",gtrigger)
    set_param_run(run,"trig_on",trig_on)
    set_param_run(run,"preamp_on",preamp_on)
    set_param_run(run,"high_gain",high_gain)
    set_param_run(run,"low_gain",low_gain)
    set_param_run(run,"launch_root",launch_root)

    timed_acq(acq_name,run,float(acq_time)*60)
    wait_run_finished(run)
    if launch_root=="ON":
        rawfilename = "/home/data/%s/%s_by_dif0.raw"%(run_name,acq_name)
        rc_exec("/opt/root_scripts/forFG/electronics %s"%(rawfilename))

def tdc_charge_response_hg_lg_get_progress():
    # progress_acq is updated by the function timed_acq
    return progress_acq

execfile("/opt/calicoes/pycaldaq_rcs.py")

